



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>CoreCLR源码探索(三) GC内存分配器的内部实现</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">CoreCLR源码探索(三) GC内存分配器的内部实现</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-28 19:20:52 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>在前一篇中我讲解了new是怎么工作的, 但是却一笔跳过了内存分配相关的部分.<br /><br />
在这一篇中我将详细讲解GC内存分配器的内部实现.<br /><br />
在看这一篇之前请必须先看完微软BOTR文档中的&quot;Garbage Collection Design&quot;,<br /><br />
原文地址是: <a href="https://github.com/dotnet/coreclr/blob/master/Documentation/botr/garbage-collection.md" rel="external nofollow noreferrer">https://github.com/dotnet/coreclr/blob/master/Documentation/botr/garbage-collection.md</a><br /><br />
译文可以看<a href="http://www.cnblogs.com/vowei/p/5493051.html" rel="external nofollow noreferrer">知平软件的译文</a>或<a href="http://www.cnblogs.com/zkweb/p/6288457.html" rel="external nofollow noreferrer">我后来的译文</a><br /><br />
请务必先看完&quot;Garbage Collection Design&quot;, 否则以下内容你很可能会无法理解</p>
<h3>服务器GC和工作站GC</h3>
<p>关于服务器GC和工作站GC的区别, 网上已经有很多资料讲解这篇就不再说明了.<br /><br />
我们来看服务器GC和工作站GC的代码是怎么区别开来的.<br /><br />
默认编译CoreCLR会对同一份代码以使用服务器GC还是工作站GC的区别编译两次, 分别在SVR和WKS命名空间中:</p>
<p>源代码: <a href="https://github.com/dotnet/coreclr/blob/release/1.1.0/src/gc/gcsvr.cpp" rel="external nofollow noreferrer">https://github.com/dotnet/coreclr/blob/release/1.1.0/src/gc/gcsvr.cpp</a></p>
<pre class="prettyprint linenums"><code>#define SERVER_GC 1

namespace SVR {<br />
#include &quot;gcimpl.h&quot;<br />
#include &quot;gc.cpp&quot;<br />
}<br />
</code></pre>
<p>源代码: <a href="https://github.com/dotnet/coreclr/blob/release/1.1.0/src/gc/gcwks.cpp" rel="external nofollow noreferrer">https://github.com/dotnet/coreclr/blob/release/1.1.0/src/gc/gcwks.cpp</a></p>
<pre class="prettyprint linenums"><code>#ifdef SERVER_GC<br />
#undef SERVER_GC<br />
#endif

namespace WKS {<br />
#include &quot;gcimpl.h&quot;<br />
#include &quot;gc.cpp&quot;<br />
}<br />
</code></pre>
<p>当定义了SERVER_GC时, MULTIPLE_HEAPS和会被同时定义.<br /><br />
定义了MULTIPLE_HEAPS会使用多个堆(Heap), 服务器GC每个cpu核心都会对应一个堆(默认), 工作站GC则全局使用同一个堆.</p>
<p>源代码: <a href="https://github.com/dotnet/coreclr/blob/release/1.1.0/src/gc/gcimpl.h" rel="external nofollow noreferrer">https://github.com/dotnet/coreclr/blob/release/1.1.0/src/gc/gcimpl.h</a></p>
<pre class="prettyprint linenums"><code>#ifdef SERVER_GC<br />
#define MULTIPLE_HEAPS 1<br />
#endif // SERVER_GC<br />
</code></pre>
<p>后台GC无论是服务器GC还是工作站GC都会默认支持, 但运行时不一定会启用.</p>
<p>源代码: <a href="https://github.com/dotnet/coreclr/blob/release/1.1.0/src/gc/gcpriv.h" rel="external nofollow noreferrer">https://github.com/dotnet/coreclr/blob/release/1.1.0/src/gc/gcpriv.h</a></p>
<pre class="prettyprint linenums"><code>#define BACKGROUND_GC //concurrent background GC (requires WRITE_WATCH)<br />
</code></pre>
<p>我们从https://www.microsoft.com/net下回来的CoreCLR安装包中已经包含了服务器GC和后台GC的支持，但默认不会开启.<br /><br />
开启它们可以修改project.json中的·runtimeOptions·节, 例子如下:</p>
<pre class="prettyprint linenums"><code>{<br />
  &quot;runtimeOptions&quot;: {<br />
    &quot;configProperties&quot;: {<br />
      &quot;System.GC.Server&quot;: true,<br />
      &quot;System.GC.Concurrent&quot;: true<br />
    }<br />
  }<br />
}<br />
</code></pre>
<p>设置后发布项目可以看到coreapp.runtimeconfig.json, 运行时会只看这个文件.<br /><br />
微软官方的文档: <a href="https://docs.microsoft.com/en-us/dotnet/articles/core/tools/project-json" rel="external nofollow noreferrer">https://docs.microsoft.com/en-us/dotnet/articles/core/tools/project-json</a></p>
<h3>GC相关的类和它们的关系</h3>
<p>我先用两张图来解释服务器GC和工作站GC下GC相关的类的关系<br /><br />
<img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/881857/201702/881857-20170208170946447-1992657701.jpg"><br /><br />
<img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/881857/201702/881857-20170208170955432-1684336872.jpg"></p>
<p>图中一共有5个类型</p>
<ul><li>GCHeap</p>
<ul><li><strong>实现了IGCHeap接口, 公开GC层的接口给EE(运行引擎)层调用</strong></li>
<li>在工作站GC下只有一个实例, 不会关联gc_heap对象, 因为工作站GC下gc_heap的所有成员都会被定义为静态变量</li>
<li>在服务器GC下有1+cpu核心数个实例(默认), 第一个实例用于当接口, 其它对应cpu核心的实例都会各关联一个gc_heap实例</li></ul></li>
<li>gc_heap
<ul><li><strong>内部的使用的堆类型, 用于负责内存的分配和回收</strong></li>
<li>在工作站GC下无实例, 所有成员都会定义为静态变量</li>
<li>在工作站GC下generation_table这个成员不会被定义, 而是使用全局变量generation_table</li>
<li>在服务器GC下有cpu核心数个实例(默认), 各关联一个GCHeap实例</li></ul></li>
<li>generation
<ul><li><strong>储存各个代的信息, 例如地址范围和使用的段</strong></li>
<li>储存在generation_table中, 一个generation_table包含了5个generation, 前面的是0 1 2 3代, 最后一个不会被初始化和使用</li>
<li>在工作站GC下只有1个generation_table, 就是全局变量generation_table</li>
<li>在服务器GC下generation_table是gc_heap的成员, 有多少个gc_heap就有多少个generation_table</li></ul></li>
<li>heap_segment
<ul><li><strong>堆段, 供分配器使用的一段内存, 用链表形式保存</strong></li>
<li>每个gc_heap中都有一个或一个以上的segment</li>
<li>每个gc_heap中都有一个ephemeral heap segment(用于存放最年轻对象)</li>
<li>每个gc_heap中都有一个large heap segment(用于存放大对象)</li>
<li>在工作站GC下segment的默认大小是256M(0x10000000字节)</li>
<li>在服务器GC下segment的默认大小是4G(0x100000000字节)</li></ul></li>
<li>alloc_context
<ul><li><strong>分配上下文, 指向segment中的一个范围, 用于实际分配对象</strong></li>
<li>每个线程都有自己的分配上下文, 因为指向的范围不一样所以只要当前范围还有足够空间, 分配对象时不需要线程锁</li>
<li>分配上下文的默认范围是8K, 也叫分配单位(Allocation Quantum)</li>
<li>分配小对象时会从这8K中分配, 分配大对象时则会直接从段(segment)中分配</li>
<li>代0(gen 0)还有一个默认的分配上下文供内部使用, 和线程无关</li></ul></li></ul>
<p>GCHeap的源代码摘要:</p>
<p>GCHeap的定义: <a href="https://github.com/dotnet/coreclr/blob/release/1.1.0/src/gc/gcimpl.h#L61" rel="external nofollow noreferrer">https://github.com/dotnet/coreclr/blob/release/1.1.0/src/gc/gcimpl.h#L61</a><br /><br />
这里我只列出这篇文章涉及到的成员</p>
<pre class="prettyprint linenums"><code>// WKS::GCHeap或SVR::GCHeap继承全局命名空间下的GCHeap<br />
class GCHeap : public ::GCHeap<br />
{<br />
#ifdef MULTIPLE_HEAPS<br />
    // 服务器GC每个GCHeap实例都会和一个gc_heap实例互相关联<br />
    gc_heap*    pGenGCHeap;<br />
#else<br />
    // 工作站GC下gc_heap所有字段和函数都是静态的, 所以可以用((gc_heap*)nullptr)-&gt;xxx来访问<br />
    // 严格来说是UB(未定义动作), 但是实际可以工作<br />
    #define pGenGCHeap ((gc_heap*)0)<br />
#endif //MULTIPLE_HEAPS<br />
};<br />
</code></pre>
<p>全局的GCHeap实例: <a href="https://github.com/dotnet/coreclr/blob/release/1.1.0/src/gc/gc.h#L105" rel="external nofollow noreferrer">https://github.com/dotnet/coreclr/blob/release/1.1.0/src/gc/gc.h#L105</a><br /><br />
这里是1.1.0的代码, 1.2.0全局GCHeap会分别保存到gcheaputilities.h(g_pGCHeap)和gc.cpp(g_theGCHeap), 两处地方都指向同一个实例.</p>
<pre class="prettyprint linenums"><code>// 相当于extern GCHeap* g_pGCHeap;<br />
GPTR_DECL(GCHeap, g_pGCHeap);<br />
</code></pre>
<p>gc_heap的源代码摘要:</p>
<p>gc_heap的定义: <a href="https://github.com/dotnet/coreclr/blob/release/1.1.0/src/gc/gcpriv.h#L1079" rel="external nofollow noreferrer">https://github.com/dotnet/coreclr/blob/release/1.1.0/src/gc/gcpriv.h#L1079</a><br /><br />
这个类有300多个成员(从ephemeral_low开始), 这里我只列出这篇文章涉及到的成员</p>
<pre class="prettyprint linenums"><code>class gc_heap<br />
{<br />
#ifdef MULTIPLE_HEAPS<br />
    // 对应的GCHeap实例<br />
    PER_HEAP GCHeap* vm_heap;<br />
    // 序号<br />
    PER_HEAP int heap_number;<br />
    // 给分配上下文设置内存范围的次数<br />
    PER_HEAP VOLATILE(int) alloc_context_count;<br />
#else //MULTIPLE_HEAPS<br />
    // 工作站GC时对应全局的GCHeap实例<br />
    #define vm_heap ((GCHeap*) g_pGCHeap)<br />
    // 工作站GC时序号为0<br />
    #define heap_number (0)<br />
#endif //MULTIPLE_HEAPS

#ifndef MULTIPLE_HEAPS<br />
    // 当前使用的短暂的堆段(用于分配新对象的堆段)<br />
    SPTR_DECL(heap_segment,ephemeral_heap_segment);<br />
#else<br />
    // 同上<br />
    PER_HEAP heap_segment* ephemeral_heap_segment;<br />
#endif // !MULTIPLE_HEAPS

    // 全局GC线程锁, 静态变量<br />
    PER_HEAP_ISOLATED GCSpinLock gc_lock; //lock while doing GC<br />
    // 分配上下文用完, 需要为分配上下文指定新的范围时使用的线程锁<br />
    PER_HEAP GCSpinLock more_space_lock; //lock while allocating more space

#ifdef MULTIPLE_HEAPS<br />
    // 储存各个代的信息<br />
    // NUMBERGENERATIONS+1=5, 代分别有0 1 2 3, 最后一个元素不会被使用<br />
    // 工作站GC时不会定义, 而是使用全局变量generation_table<br />
    PER_HEAP generation generation_table [NUMBERGENERATIONS+1];<br />
#endif

#ifdef MULTIPLE_HEAPS<br />
    // 全局gc_heap的数量, 静态变量<br />
    // 服务器GC默认是cpu核心数, 工作站GC是0<br />
    SVAL_DECL(int, n_heaps);<br />
    // 全局gc_heap的数组, 静态变量<br />
    SPTR_DECL(PTR_gc_heap, g_heaps);<br />
#endif<br />
};<br />
</code></pre>
<p>generation的源代码摘要:</p>
<p>generation的定义: <a href="https://github.com/dotnet/coreclr/blob/release/1.1.0/src/gc/gcpriv.h#L754" rel="external nofollow noreferrer">https://github.com/dotnet/coreclr/blob/release/1.1.0/src/gc/gcpriv.h#L754</a><br /><br />
这里我只列出这篇文章涉及到的成员</p>
<pre class="prettyprint linenums"><code>class generation<br />
{<br />
public:<br />
    // 默认的分配上下文<br />
    alloc_context   allocation_context;<br />
    // 用于分配的最新的堆段<br />
    heap_segment*   allocation_segment;<br />
    // 开始的堆段<br />
    PTR_heap_segment start_segment;<br />
    // 用于区分对象在哪个代的指针, 在此之后的对象都属于这个代, 或比这个代更年轻的代<br />
    uint8_t*        allocation_start;<br />
    // 用于储存和分配自由对象（Free Object, 又名Unused Array, 可以理解为碎片空间)的分配器<br />
    allocator       free_list_allocator;<br />
    // 这个代是第几代<br />
    int gen_num;<br />
};<br />
</code></pre>
<p>heap_segment的源代码摘要:</p>
<p>heap_segment的定义: <a href="https://github.com/dotnet/coreclr/blob/release/1.1.0/src/gc/gcpriv.h#L4166" rel="external nofollow noreferrer">https://github.com/dotnet/coreclr/blob/release/1.1.0/src/gc/gcpriv.h#L4166</a><br /><br />
这里我只列出这篇文章涉及到的成员</p>
<pre class="prettyprint linenums"><code>class heap_segment<br />
{<br />
public:<br />
    // 已实际分配地址 (mem + 已分配大小)<br />
    // 更新有可能会延迟<br />
    uint8_t*        allocated;<br />
    // 已提交到物理内存的地址 (this + SEGMENT_INITIAL_COMMIT)<br />
    uint8_t*        committed;<br />
    // 预留到的分配地址 (this + size)<br />
    uint8_t*        reserved;<br />
    // 已使用地址 (mem + 已分配大小 - 对象头大小)<br />
    uint8_t*        used;<br />
    // 初始分配地址 (服务器gc开启时: this + OS_PAGE_SIZE, 否则: this + sizeof(*this) + alignment)<br />
    uint8_t*        mem;<br />
    // 下一个堆段<br />
    PTR_heap_segment next;<br />
    // 属于的gc_heap实例<br />
    gc_heap*        heap;<br />
};<br />
</code></pre>
<p>alloc_context的源代码摘要:</p>
<p>alloc_context的定义: <a href="https://github.com/dotnet/coreclr/blob/release/1.1.0/src/gc/gc.h#L162" rel="external nofollow noreferrer">https://github.com/dotnet/coreclr/blob/release/1.1.0/src/gc/gc.h#L162</a><br /><br />
这里是1.1.0的代码, 1.2.0这些成员移动到了gcinterface.h的gc_alloc_context, 但是成员还是一样的</p>
<pre class="prettyprint linenums"><code>struct alloc_context<br />
{<br />
    // 下一次分配对象的开始地址<br />
    uint8_t*       alloc_ptr;<br />
    // 可以分配到的最终地址<br />
    uint8_t*       alloc_limit;<br />
    // 历史分配的小对象大小合计<br />
    int64_t        alloc_bytes; //Number of bytes allocated on SOH by this context<br />
    // 历史分配的大对象大小合计<br />
    int64_t        alloc_bytes_loh; //Number of bytes allocated on LOH by this context<br />
#if defined(FEATURE_SVR_GC)<br />
    // 空间不够需要获取更多空间时使用的GCHeap<br />
    // 分alloc_heap和home_heap的作用是平衡各个heap的使用量，这样并行回收时可以减少处理各个heap的时间差异<br />
    SVR::GCHeap*   alloc_heap;<br />
    // 原来的GCHeap<br />
    SVR::GCHeap*   home_heap;<br />
#endif // defined(FEATURE_SVR_GC)<br />
    // 历史分配对象次数<br />
    int            alloc_count;<br />
};<br />
</code></pre>
<h3>堆段的物理结构</h3>
<p>为了更好理解下面即将讲解的代码，请先看这两张图片<br /><br />
<img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/881857/201702/881857-20170208171033635-1731680738.jpg"><br /><br />
<img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/881857/201708/881857-20170822084622933-1202334187.jpg"></p>
<h3>分配对象内存的代码流程</h3>
<p>还记得上篇我提到过的AllocateObject函数吗? 这个函数由JIT_New调用, 负责分配一个普通的对象.<br /><br />
让我们来继续跟踪这个函数的内部吧:</p>
<p>AllocateObject函数的内容: <a href="https://github.com/dotnet/coreclr/blob/release/1.1.0/src/vm/gchelpers.cpp#L931" rel="external nofollow noreferrer">https://github.com/dotnet/coreclr/blob/release/1.1.0/src/vm/gchelpers.cpp#L931</a><br /><br />
AllocateObject的其他版本同样也会调用AllocAlign8或Alloc函数, 下面就不再贴出其他版本的函数代码了.</p>
<pre class="prettyprint linenums"><code>OBJECTREF AllocateObject(MethodTable *pMT<br />
#ifdef FEATURE_COMINTEROP<br />
                         , bool fHandleCom<br />
#endif<br />
    )<br />
{<br />
    // 省略部分代码......<br />
    Object     *orObject = NULL;

    // 调用gc的帮助函数分配内存，如果需要向8对齐则调用AllocAlign8，否则调用Alloc<br />
    if (pMT-&gt;RequiresAlign8())<br />
    {<br />
        // 省略部分代码......<br />
        orObject = (Object *) AllocAlign8(baseSize,<br />
                                          pMT-&gt;HasFinalizer(),<br />
                                          pMT-&gt;ContainsPointers(),<br />
                                          pMT-&gt;IsValueType());<br />
    }<br />
    else<br />
    {<br />
        orObject = (Object *) Alloc(baseSize,<br />
                                    pMT-&gt;HasFinalizer(),<br />
                                    pMT-&gt;ContainsPointers());<br />
    }

    // 省略部分代码......<br />
    return UNCHECKED_OBJECTREF_TO_OBJECTREF(oref);<br />
}<br />
</code></pre>
<p>Alloc函数的内容: <a href="https://github.com/dotnet/coreclr/blob/release/1.1.0/src/vm/gchelpers.cpp#L931" rel="external nofollow noreferrer">https://github.com/dotnet/coreclr/blob/release/1.1.0/src/vm/gchelpers.cpp#L931</a></p>
<pre class="prettyprint linenums"><code>inline Object* Alloc(size_t size, BOOL bFinalize, BOOL bContainsPointers )<br />
{<br />
    // 省略部分代码......<br />
    // 如果启用分配上下文，则使用当前线程的分配上下文进行分配<br />
    // 否则使用代(generation)中默认的分配上下文进行分配<br />
    // 按官方的说法绝大部分情况下都会启用分配上下文<br />
    // 实测的机器上UseAllocationContexts函数会不经过判断直接返回true<br />
    if (GCHeap::UseAllocationContexts())<br />
        retVal = GCHeap::GetGCHeap()-&gt;Alloc(GetThreadAllocContext(), size, flags);<br />
    else<br />
        retVal = GCHeap::GetGCHeap()-&gt;Alloc(size, flags);<br />
    // 省略部分代码......<br />
    return retVal;<br />
}<br />
</code></pre>
<p>GetGCHeap函数的内容: <a href="https://github.com/dotnet/coreclr/blob/release/1.1.0/src/gc/gc.h#L377" rel="external nofollow noreferrer">https://github.com/dotnet/coreclr/blob/release/1.1.0/src/gc/gc.h#L377</a></p>
<pre class="prettyprint linenums"><code>static GCHeap *GetGCHeap()<br />
{<br />
    LIMITED_METHOD_CONTRACT;<br />
    // 返回全局的GCHeap实例<br />
    // 注意这个实例只作为接口使用，不和具体的gc_heap实例关联<br />
    _ASSERTE(g_pGCHeap != NULL);<br />
    return g_pGCHeap;<br />
}<br />
</code></pre>
<p>GetThreadAllocContext函数的内容: <a href="https://github.com/dotnet/coreclr/blob/release/1.1.0/src/vm/gchelpers.cpp#L54" rel="external nofollow noreferrer">https://github.com/dotnet/coreclr/blob/release/1.1.0/src/vm/gchelpers.cpp#L54</a></p>
<pre class="prettyprint linenums"><code>inline alloc_context* GetThreadAllocContext()<br />
{<br />
    WRAPPER_NO_CONTRACT;

    assert(GCHeap::UseAllocationContexts());<br />
    // 获取当前线程并返回m_alloc_context成员的地址<br />
    return &amp; GetThread()-&gt;m_alloc_context;<br />
}<br />
</code></pre>
<p>GCHeap::Alloc函数的内容: <a href="https://raw.githubusercontent.com/dotnet/coreclr/release/1.1.0/src/gc/gc.cpp" rel="external nofollow noreferrer">https://raw.githubusercontent.com/dotnet/coreclr/release/1.1.0/src/gc/gc.cpp</a></p>
<pre class="prettyprint linenums"><code>Object*<br />
GCHeap::Alloc(alloc_context* acontext, size_t size, uint32_t flags REQD_ALIGN_DCL)<br />
{<br />
    // 省略部分代码......<br />
    Object* newAlloc = NULL;

    // 如果分配上下文是第一次使用，使用AssignHeap函数先给它对应一个GCHeap实例<br />
#ifdef MULTIPLE_HEAPS<br />
    if (acontext-&gt;alloc_heap == 0)<br />
    {<br />
        AssignHeap (acontext);<br />
        assert (acontext-&gt;alloc_heap);<br />
    }<br />
#endif //MULTIPLE_HEAPS

    // 必要时触发GC<br />
#ifndef FEATURE_REDHAWK<br />
    GCStress&lt;gc_on_alloc&gt;::MaybeTrigger(acontext);<br />
#endif // FEATURE_REDHAWK

    // 服务器GC使用GCHeap对应的gc_heap, 工作站GC使用nullptr<br />
#ifdef MULTIPLE_HEAPS<br />
    gc_heap* hp = acontext-&gt;alloc_heap-&gt;pGenGCHeap;<br />
#else<br />
    gc_heap* hp = pGenGCHeap;<br />
    // 省略部分代码......<br />
#endif //MULTIPLE_HEAPS

    // 分配小对象时使用allocate函数, 分配大对象时使用allocate_large_object函数<br />
    if (size &lt; LARGE_OBJECT_SIZE)<br />
    {

#ifdef TRACE_GC<br />
        AllocSmallCount++;<br />
#endif //TRACE_GC<br />
        // 分配小对象内存<br />
        newAlloc = (Object*) hp-&gt;allocate (size + ComputeMaxStructAlignPad(requiredAlignment), acontext);<br />
#ifdef FEATURE_STRUCTALIGN<br />
        // 对齐指针<br />
        newAlloc = (Object*) hp-&gt;pad_for_alignment ((uint8_t*) newAlloc, requiredAlignment, size, acontext);<br />
#endif // FEATURE_STRUCTALIGN<br />
//        ASSERT (newAlloc);<br />
    }<br />
    else<br />
    {<br />
        // 分配大对象内存<br />
        newAlloc = (Object*) hp-&gt;allocate_large_object (size + ComputeMaxStructAlignPadLarge(requiredAlignment), acontext-&gt;alloc_bytes_loh);<br />
#ifdef FEATURE_STRUCTALIGN<br />
        // 对齐指针<br />
        newAlloc = (Object*) hp-&gt;pad_for_alignment_large ((uint8_t*) newAlloc, requiredAlignment, size);<br />
#endif // FEATURE_STRUCTALIGN<br />
    }

    // 省略部分代码......<br />
    return newAlloc;<br />
}<br />
</code></pre>
<h3>分配小对象内存的代码流程</h3>
<p>让我们来看一下小对象的内存是如何分配的</p>
<p>allocate函数的内容: <a href="https://raw.githubusercontent.com/dotnet/coreclr/release/1.1.0/src/gc/gc.cpp" rel="external nofollow noreferrer">https://raw.githubusercontent.com/dotnet/coreclr/release/1.1.0/src/gc/gc.cpp</a><br /><br />
这个函数尝试从分配上下文分配内存, 失败时调用allocate_more_space为分配上下文指定新的空间<br /><br />
这里的前半部分的处理还有汇编版本, 可以看上一篇分析的<code>JIT_TrialAllocSFastMP_InlineGetThread</code>函数</p>
<pre class="prettyprint linenums"><code>inline<br />
CObjectHeader* gc_heap::allocate (size_t jsize, alloc_context* acontext)<br />
{<br />
    size_t size = Align (jsize);<br />
    assert (size &gt;= Align (min_obj_size));<br />
    {<br />
    retry:<br />
        // 尝试把对象分配到alloc_ptr<br />
        uint8_t*  result = acontext-&gt;alloc_ptr;<br />
        acontext-&gt;alloc_ptr+=size;<br />
        // 如果alloc_ptr + 对象大小 &gt; alloc_limit, 则表示这个分配上下文是第一次使用或者剩余空间已经不够用了<br />
        if (acontext-&gt;alloc_ptr &lt;= acontext-&gt;alloc_limit)<br />
        {<br />
            // 分配成功, 这里返回的地址就是+=size之前的alloc_ptr<br />
            CObjectHeader* obj = (CObjectHeader*)result;<br />
            assert (obj != 0);<br />
            return obj;<br />
        }<br />
        else<br />
        {<br />
            // 分配失败, 把size减回去<br />
            acontext-&gt;alloc_ptr -= size;

#ifdef _MSC_VER<br />
#pragma inline_depth(0)<br />
#endif //_MSC_VER<br />
            // 尝试为分配上下文重新指定一块范围<br />
            if (! allocate_more_space (acontext, size, 0))<br />
                return 0;

#ifdef _MSC_VER<br />
#pragma inline_depth(20)<br />
#endif //_MSC_VER<br />
            // 重试<br />
            goto retry;<br />
        }<br />
    }<br />
}<br />
</code></pre>
<p>allocate_more_space函数的内容: <a href="https://raw.githubusercontent.com/dotnet/coreclr/release/1.1.0/src/gc/gc.cpp" rel="external nofollow noreferrer">https://raw.githubusercontent.com/dotnet/coreclr/release/1.1.0/src/gc/gc.cpp</a><br /><br />
这个函数会在有多个heap时调用balance_heaps平衡各个heap的使用量, 然后再调用try_allocate_more_space函数</p>
<pre class="prettyprint linenums"><code>BOOL gc_heap::allocate_more_space(alloc_context* acontext, size_t size,<br />
                                  int alloc_generation_number)<br />
{<br />
    int status;<br />
    do<br />
    {<br />
        // 如果有多个heap需要先平衡它们的使用量以减少并行回收时的处理时间差<br />
#ifdef MULTIPLE_HEAPS<br />
        if (alloc_generation_number == 0)<br />
        {<br />
            // 平衡各个heap的使用量<br />
            balance_heaps (acontext);<br />
            // 调用try_allocate_more_space函数<br />
            status = acontext-&gt;alloc_heap-&gt;pGenGCHeap-&gt;try_allocate_more_space (acontext, size, alloc_generation_number);<br />
        }<br />
        else<br />
        {<br />
            // 平衡各个heap的使用量(大对象)<br />
            gc_heap* alloc_heap = balance_heaps_loh (acontext, size);<br />
            // 调用try_allocate_more_space函数<br />
            status = alloc_heap-&gt;try_allocate_more_space (acontext, size, alloc_generation_number);<br />
        }<br />
#else<br />
        // 只有一个heap时直接调用try_allocate_more_space函数<br />
        status = try_allocate_more_space (acontext, size, alloc_generation_number);<br />
#endif //MULTIPLE_HEAPS<br />
    }<br />
    while (status == -1);

    return (status != 0);<br />
}<br />
</code></pre>
<p>try_allocate_more_space函数的内容: <a href="https://raw.githubusercontent.com/dotnet/coreclr/release/1.1.0/src/gc/gc.cpp" rel="external nofollow noreferrer">https://raw.githubusercontent.com/dotnet/coreclr/release/1.1.0/src/gc/gc.cpp</a><br /><br />
这个函数会获取MSL锁, 检查是否有必要触发GC, 然后根据gen_number参数调用allocate_small或allocate_large函数</p>
<pre class="prettyprint linenums"><code>int gc_heap::try_allocate_more_space (alloc_context* acontext, size_t size,<br />
                                   int gen_number)<br />
{<br />
    // gc已经开始时等待gc完成并重试<br />
    // allocate函数会跑到retry再调用这个函数<br />
    if (gc_heap::gc_started)<br />
    {<br />
        wait_for_gc_done();<br />
        return -1;<br />
    }

    // 获取more_space_lock锁<br />
    // 并且统计获取锁需要的时间是否多或者少<br />
#ifdef SYNCHRONIZATION_STATS<br />
    unsigned int msl_acquire_start = GetCycleCount32();<br />
#endif //SYNCHRONIZATION_STATS<br />
    enter_spin_lock (&amp;more_space_lock);<br />
    add_saved_spinlock_info (me_acquire, mt_try_alloc);<br />
    dprintf (SPINLOCK_LOG, (&quot;[%d]Emsl for alloc&quot;, heap_number));<br />
#ifdef SYNCHRONIZATION_STATS<br />
    unsigned int msl_acquire = GetCycleCount32() - msl_acquire_start;<br />
    total_msl_acquire += msl_acquire;<br />
    num_msl_acquired++;<br />
    if (msl_acquire &gt; 200)<br />
    {<br />
        num_high_msl_acquire++;<br />
    }<br />
    else<br />
    {<br />
        num_low_msl_acquire++;<br />
    }<br />
#endif //SYNCHRONIZATION_STATS

    // 这部分的代码被注释了<br />
    // 因为获取msl(more space lock)锁已经可以防止问题出现<br />
    /*<br />
    // We are commenting this out 'cause we don't see the point - we already<br />
    // have checked gc_started when we were acquiring the msl - no need to check<br />
    // again. This complicates the logic in bgc_suspend_EE 'cause that one would<br />
    // need to release msl which causes all sorts of trouble.<br />
    if (gc_heap::gc_started)<br />
    {<br />
#ifdef SYNCHRONIZATION_STATS<br />
        good_suspension++;<br />
#endif //SYNCHRONIZATION_STATS<br />
        BOOL fStress = (g_pConfig-&gt;GetGCStressLevel() &amp; EEConfig::GCSTRESS_TRANSITION) != 0;<br />
        if (!fStress)<br />
        {<br />
            //Rendez vous early (MP scaling issue)<br />
            //dprintf (1, (&quot;[%d]waiting for gc&quot;, heap_number));<br />
            wait_for_gc_done();<br />
#ifdef MULTIPLE_HEAPS<br />
            return -1;<br />
#endif //MULTIPLE_HEAPS<br />
        }<br />
    }<br />
    */

    dprintf (3, (&quot;requested to allocate %d bytes on gen%d&quot;, size, gen_number));<br />
    // 获取对齐使用的值<br />
    // 小对象3(0b11)或者7(0b111), 大对象7(0b111)<br />
    int align_const = get_alignment_constant (gen_number != (max_generation+1));

    // 必要时触发GC<br />
    if (fgn_maxgen_percent)<br />
    {<br />
        check_for_full_gc (gen_number, size);<br />
    }

    // 再次检查必要时触发GC<br />
    if (!(new_allocation_allowed (gen_number)))<br />
    {<br />
        if (fgn_maxgen_percent &amp;&amp; (gen_number == 0))<br />
        {<br />
            // We only check gen0 every so often, so take this opportunity to check again.<br />
            check_for_full_gc (gen_number, size);<br />
        }

        // 后台GC运行中并且物理内存占用率在95%以上时等待后台GC完成<br />
#ifdef BACKGROUND_GC<br />
        wait_for_bgc_high_memory (awr_gen0_alloc);<br />
#endif //BACKGROUND_GC

#ifdef SYNCHRONIZATION_STATS<br />
        bad_suspension++;<br />
#endif //SYNCHRONIZATION_STATS<br />
        dprintf (/*100*/ 2, (&quot;running out of budget on gen%d, gc&quot;, gen_number));

        // 必要时原地触发GC<br />
        if (!settings.concurrent || (gen_number == 0))<br />
        {<br />
            vm_heap-&gt;GarbageCollectGeneration (0, ((gen_number == 0) ? reason_alloc_soh : reason_alloc_loh));<br />
#ifdef MULTIPLE_HEAPS<br />
            // 触发GC后会释放MSL锁, 需要重新获取<br />
            enter_spin_lock (&amp;more_space_lock);<br />
            add_saved_spinlock_info (me_acquire, mt_try_budget);<br />
            dprintf (SPINLOCK_LOG, (&quot;[%d]Emsl out budget&quot;, heap_number));<br />
#endif //MULTIPLE_HEAPS<br />
        }<br />
    }

    // 根据是第几代调用不同的函数, 函数里面会给分配上下文指定新的范围<br />
    // 参数gen_number只能是0或者3<br />
    BOOL can_allocate = ((gen_number == 0) ?<br />
        allocate_small (gen_number, size, acontext, align_const) :<br />
        allocate_large (gen_number, size, acontext, align_const));

    // 成功时检查是否要触发ETW(Event Tracing for Windows)事件<br />
    if (can_allocate)<br />
    {<br />
        // 记录给了分配上下文多少字节<br />
        //ETW trace for allocation tick<br />
        size_t alloc_context_bytes = acontext-&gt;alloc_limit + Align (min_obj_size, align_const) - acontext-&gt;alloc_ptr;<br />
        int etw_allocation_index = ((gen_number == 0) ? 0 : 1);

        etw_allocation_running_amount[etw_allocation_index] += alloc_context_bytes;

        // 超过一定量时触发ETW事件<br />
        if (etw_allocation_running_amount[etw_allocation_index] &gt; etw_allocation_tick)<br />
        {<br />
#ifdef FEATURE_REDHAWK<br />
            FireEtwGCAllocationTick_V1((uint32_t)etw_allocation_running_amount[etw_allocation_index],<br />
                                    ((gen_number == 0) ? ETW::GCLog::ETW_GC_INFO::AllocationSmall : ETW::GCLog::ETW_GC_INFO::AllocationLarge),<br />
                                    GetClrInstanceId());<br />
#else<br />
            // Unfortunately some of the ETW macros do not check whether the ETW feature is enabled.<br />
            // The ones that do are much less efficient.<br />
#if defined(FEATURE_EVENT_TRACE)<br />
            if (EventEnabledGCAllocationTick_V2())<br />
            {<br />
                fire_etw_allocation_event (etw_allocation_running_amount[etw_allocation_index], gen_number, acontext-&gt;alloc_ptr);<br />
            }<br />
#endif //FEATURE_EVENT_TRACE<br />
#endif //FEATURE_REDHAWK<br />
            // 重置量<br />
            etw_allocation_running_amount[etw_allocation_index] = 0;<br />
        }<br />
    }

    return (int)can_allocate;<br />
}<br />
</code></pre>
<p>allocate_small函数的内容: <a href="https://raw.githubusercontent.com/dotnet/coreclr/release/1.1.0/src/gc/gc.cpp" rel="external nofollow noreferrer">https://raw.githubusercontent.com/dotnet/coreclr/release/1.1.0/src/gc/gc.cpp</a><br /><br />
循环尝试进行各种回收内存的处理和调用soh_try_fit函数, soh_try_fit函数分配成功或手段已经用尽时跳出循环</p>
<pre class="prettyprint linenums"><code>BOOL gc_heap::allocate_small (int gen_number,<br />
                              size_t size,<br />
                              alloc_context* acontext,<br />
                              int align_const)<br />
{<br />
    // 工作站GC且后台GC运行时140次(bgc_alloc_spin_count)休眠1次, 休眠时间2ms(bgc_alloc_spin)<br />
#if defined (BACKGROUND_GC) &amp;&amp; !defined (MULTIPLE_HEAPS)<br />
    if (recursive_gc_sync::background_running_p())<br />
    {<br />
        background_soh_alloc_count++;<br />
        if ((background_soh_alloc_count % bgc_alloc_spin_count) == 0)<br />
        {<br />
            Thread* current_thread = GetThread();<br />
            add_saved_spinlock_info (me_release, mt_alloc_small);<br />
            dprintf (SPINLOCK_LOG, (&quot;[%d]spin Lmsl&quot;, heap_number));<br />
            leave_spin_lock (&amp;more_space_lock);<br />
            BOOL cooperative_mode = enable_preemptive (current_thread);<br />
            GCToOSInterface::Sleep (bgc_alloc_spin);<br />
            disable_preemptive (current_thread, cooperative_mode);<br />
            enter_spin_lock (&amp;more_space_lock);<br />
            add_saved_spinlock_info (me_acquire, mt_alloc_small);<br />
            dprintf (SPINLOCK_LOG, (&quot;[%d]spin Emsl&quot;, heap_number));<br />
        }<br />
        else<br />
        {<br />
            //GCToOSInterface::YieldThread (0);<br />
        }<br />
    }<br />
#endif //BACKGROUND_GC &amp;&amp; !MULTIPLE_HEAPS

    gc_reason gr = reason_oos_soh;<br />
    oom_reason oom_r = oom_no_failure;

    // No variable values should be &quot;carried over&quot; from one state to the other.<br />
    // That's why there are local variable for each state

    allocation_state soh_alloc_state = a_state_start;

    // 开始循环切换状态, 请关注soh_alloc_state<br />
    // If we can get a new seg it means allocation will succeed.<br />
    while (1)<br />
    {<br />
        dprintf (3, (&quot;[h%d]soh state is %s&quot;, heap_number, allocation_state_str[soh_alloc_state]));<br />
        switch (soh_alloc_state)<br />
        {<br />
            // 成功或失败时跳出循环<br />
            case a_state_can_allocate:<br />
            case a_state_cant_allocate:<br />
            {<br />
                goto exit;<br />
            }<br />
            // 开始时切换状态到a_state_try_fit<br />
            case a_state_start:<br />
            {<br />
                soh_alloc_state = a_state_try_fit;<br />
                break;<br />
            }<br />
            // 调用soh_try_fit函数<br />
            // 成功时切换状态到a_state_can_allocate<br />
            // 失败时切换状态到a_state_trigger_full_compact_gc或a_state_trigger_ephemeral_gc<br />
            case a_state_try_fit:<br />
            {<br />
                BOOL commit_failed_p = FALSE;<br />
                BOOL can_use_existing_p = FALSE;

                can_use_existing_p = soh_try_fit (gen_number, size, acontext,<br />
                                                  align_const, &amp;commit_failed_p,<br />
                                                  NULL);<br />
                soh_alloc_state = (can_use_existing_p ?<br />
                                        a_state_can_allocate :<br />
                                        (commit_failed_p ?<br />
                                            a_state_trigger_full_compact_gc :<br />
                                            a_state_trigger_ephemeral_gc));<br />
                break;<br />
            }<br />
            // 后台GC完成后调用soh_try_fit函数<br />
            // 成功时切换状态到a_state_can_allocate<br />
            // 失败时切换状态到a_state_trigger_2nd_ephemeral_gc或a_state_trigger_full_compact_gc<br />
            case a_state_try_fit_after_bgc:<br />
            {<br />
                BOOL commit_failed_p = FALSE;<br />
                BOOL can_use_existing_p = FALSE;<br />
                BOOL short_seg_end_p = FALSE;

                can_use_existing_p = soh_try_fit (gen_number, size, acontext,<br />
                                                  align_const, &amp;commit_failed_p,<br />
                                                  &amp;short_seg_end_p);<br />
                soh_alloc_state = (can_use_existing_p ?<br />
                                        a_state_can_allocate :<br />
                                        (short_seg_end_p ?<br />
                                            a_state_trigger_2nd_ephemeral_gc :<br />
                                            a_state_trigger_full_compact_gc));<br />
                break;<br />
            }<br />
            // 压缩GC完成后调用soh_try_fit函数<br />
            // 如果压缩后仍分配失败则切换状态到a_state_cant_allocate<br />
            // 成功时切换状态到a_state_can_allocate<br />
            case a_state_try_fit_after_cg:<br />
            {<br />
                BOOL commit_failed_p = FALSE;<br />
                BOOL can_use_existing_p = FALSE;<br />
                BOOL short_seg_end_p = FALSE;

                can_use_existing_p = soh_try_fit (gen_number, size, acontext,<br />
                                                  align_const, &amp;commit_failed_p,<br />
                                                  &amp;short_seg_end_p);<br />
                if (short_seg_end_p)<br />
                {<br />
                    soh_alloc_state = a_state_cant_allocate;<br />
                    oom_r = oom_budget;<br />
                }<br />
                else<br />
                {<br />
                    if (can_use_existing_p)<br />
                    {<br />
                        soh_alloc_state = a_state_can_allocate;<br />
                    }<br />
                    else<br />
                    {<br />
#ifdef MULTIPLE_HEAPS<br />
                        if (!commit_failed_p)<br />
                        {<br />
                            // some other threads already grabbed the more space lock and allocated<br />
                            // so we should attemp an ephemeral GC again.<br />
                            assert (heap_segment_allocated (ephemeral_heap_segment) &lt; alloc_allocated);<br />
                            soh_alloc_state = a_state_trigger_ephemeral_gc;<br />
                        }<br />
                        else<br />
#endif //MULTIPLE_HEAPS<br />
                        {<br />
                            assert (commit_failed_p);<br />
                            soh_alloc_state = a_state_cant_allocate;<br />
                            oom_r = oom_cant_commit;<br />
                        }<br />
                    }<br />
                }<br />
                break;<br />
            }<br />
            // 等待后台GC完成<br />
            // 如果执行了压缩则切换状态到a_state_try_fit_after_cg<br />
            // 否则切换状态到a_state_try_fit_after_bgc<br />
            case a_state_check_and_wait_for_bgc:<br />
            {<br />
                BOOL bgc_in_progress_p = FALSE;<br />
                BOOL did_full_compacting_gc = FALSE;

                bgc_in_progress_p = check_and_wait_for_bgc (awr_gen0_oos_bgc, &amp;did_full_compacting_gc);<br />
                soh_alloc_state = (did_full_compacting_gc ?<br />
                                        a_state_try_fit_after_cg :<br />
                                        a_state_try_fit_after_bgc);<br />
                break;<br />
            }<br />
            // 触发第0和1代的GC<br />
            // 如果有压缩则切换状态到a_state_try_fit_after_cg<br />
            // 否则重试soh_try_fit, 成功时切换状态到a_state_can_allocate, 失败时切换状态到等待后台GC或触发其他GC<br />
            case a_state_trigger_ephemeral_gc:<br />
            {<br />
                BOOL commit_failed_p = FALSE;<br />
                BOOL can_use_existing_p = FALSE;<br />
                BOOL short_seg_end_p = FALSE;<br />
                BOOL bgc_in_progress_p = FALSE;<br />
                BOOL did_full_compacting_gc = FALSE;

                did_full_compacting_gc = trigger_ephemeral_gc (gr);<br />
                if (did_full_compacting_gc)<br />
                {<br />
                    soh_alloc_state = a_state_try_fit_after_cg;<br />
                }<br />
                else<br />
                {<br />
                    can_use_existing_p = soh_try_fit (gen_number, size, acontext,<br />
                                                      align_const, &amp;commit_failed_p,<br />
                                                      &amp;short_seg_end_p);<br />
#ifdef BACKGROUND_GC<br />
                    bgc_in_progress_p = recursive_gc_sync::background_running_p();<br />
#endif //BACKGROUND_GC

                    if (short_seg_end_p)<br />
                    {<br />
                        soh_alloc_state = (bgc_in_progress_p ?<br />
                                                a_state_check_and_wait_for_bgc :<br />
                                                a_state_trigger_full_compact_gc);

                        if (fgn_maxgen_percent)<br />
                        {<br />
                            dprintf (2, (&quot;FGN: doing last GC before we throw OOM&quot;));<br />
                            send_full_gc_notification (max_generation, FALSE);<br />
                        }<br />
                    }<br />
                    else<br />
                    {<br />
                        if (can_use_existing_p)<br />
                        {<br />
                            soh_alloc_state = a_state_can_allocate;<br />
                        }<br />
                        else<br />
                        {<br />
#ifdef MULTIPLE_HEAPS<br />
                            if (!commit_failed_p)<br />
                            {<br />
                                // some other threads already grabbed the more space lock and allocated<br />
                                // so we should attemp an ephemeral GC again.<br />
                                assert (heap_segment_allocated (ephemeral_heap_segment) &lt; alloc_allocated);<br />
                                soh_alloc_state = a_state_trigger_ephemeral_gc;<br />
                            }<br />
                            else<br />
#endif //MULTIPLE_HEAPS<br />
                            {<br />
                                soh_alloc_state = a_state_trigger_full_compact_gc;<br />
                                if (fgn_maxgen_percent)<br />
                                {<br />
                                    dprintf (2, (&quot;FGN: failed to commit, doing full compacting GC&quot;));<br />
                                    send_full_gc_notification (max_generation, FALSE);<br />
                                }<br />
                            }<br />
                        }<br />
                    }<br />
                }<br />
                break;<br />
            }<br />
            // 第二次触发第0和1代的GC<br />
            // 如果有压缩则切换状态到a_state_try_fit_after_cg<br />
            // 否则重试soh_try_fit, 成功时切换状态到a_state_can_allocate, 失败时切换状态到a_state_trigger_full_compact_gc<br />
            case a_state_trigger_2nd_ephemeral_gc:<br />
            {<br />
                BOOL commit_failed_p = FALSE;<br />
                BOOL can_use_existing_p = FALSE;<br />
                BOOL short_seg_end_p = FALSE;<br />
                BOOL did_full_compacting_gc = FALSE;

                did_full_compacting_gc = trigger_ephemeral_gc (gr);

                if (did_full_compacting_gc)<br />
                {<br />
                    soh_alloc_state = a_state_try_fit_after_cg;<br />
                }<br />
                else<br />
                {<br />
                    can_use_existing_p = soh_try_fit (gen_number, size, acontext,<br />
                                                      align_const, &amp;commit_failed_p,<br />
                                                      &amp;short_seg_end_p);<br />
                    if (short_seg_end_p || commit_failed_p)<br />
                    {<br />
                        soh_alloc_state = a_state_trigger_full_compact_gc;<br />
                    }<br />
                    else<br />
                    {<br />
                        assert (can_use_existing_p);<br />
                        soh_alloc_state = a_state_can_allocate;<br />
                    }<br />
                }<br />
                break;<br />
            }<br />
            // 触发第0和1和2代的压缩GC<br />
            // 成功时切换状态到a_state_try_fit_after_cg, 失败时切换状态到a_state_cant_allocate<br />
            case a_state_trigger_full_compact_gc:<br />
            {<br />
                BOOL got_full_compacting_gc = FALSE;

                got_full_compacting_gc = trigger_full_compact_gc (gr, &amp;oom_r);<br />
                soh_alloc_state = (got_full_compacting_gc ? a_state_try_fit_after_cg : a_state_cant_allocate);<br />
                break;<br />
            }<br />
            default:<br />
            {<br />
                assert (!&quot;Invalid state!&quot;);<br />
                break;<br />
            }<br />
        }<br />
    }

exit:<br />
    // 分配失败时处理OOM(Out Of Memory)<br />
    if (soh_alloc_state == a_state_cant_allocate)<br />
    {<br />
        assert (oom_r != oom_no_failure);<br />
        handle_oom (heap_number,<br />
                    oom_r,<br />
                    size,<br />
                    heap_segment_allocated (ephemeral_heap_segment),<br />
                    heap_segment_reserved (ephemeral_heap_segment));

        dprintf (SPINLOCK_LOG, (&quot;[%d]Lmsl for oom&quot;, heap_number));<br />
        add_saved_spinlock_info (me_release, mt_alloc_small_cant);<br />
        leave_spin_lock (&amp;more_space_lock);<br />
    }

    return (soh_alloc_state == a_state_can_allocate);<br />
}<br />
</code></pre>
<p>soh_try_fit函数的内容: <a href="https://raw.githubusercontent.com/dotnet/coreclr/release/1.1.0/src/gc/gc.cpp" rel="external nofollow noreferrer">https://raw.githubusercontent.com/dotnet/coreclr/release/1.1.0/src/gc/gc.cpp</a><br /><br />
这个函数会先尝试调用a_fit_free_list_p从自由对象列表中分配, 然后尝试调用a_fit_segment_end_p从堆段结尾分配</p>
<pre class="prettyprint linenums"><code>BOOL gc_heap::soh_try_fit (int gen_number,<br />
                           size_t size,<br />
                           alloc_context* acontext,<br />
                           int align_const,<br />
                           BOOL* commit_failed_p, // 返回参数, 把虚拟内存提交到物理内存是否失败(物理内存不足)<br />
                           BOOL* short_seg_end_p) // 返回参数, 堆段的结尾是否不够用<br />
{<br />
    BOOL can_allocate = TRUE;<br />
    // 有传入short_seg_end_p时先设置它的值为false<br />
    if (short_seg_end_p)<br />
    {<br />
        *short_seg_end_p = FALSE;<br />
    }

    // 先尝试从自由对象列表中分配<br />
    can_allocate = a_fit_free_list_p (gen_number, size, acontext, align_const);<br />
    if (!can_allocate)<br />
    {<br />
        // 不能从自由对象列表中分配, 尝试从堆段的结尾分配<br />
        // 检查ephemeral_heap_segment的结尾空间是否足够<br />
        if (short_seg_end_p)<br />
        {<br />
            *short_seg_end_p = short_on_end_of_seg (gen_number, ephemeral_heap_segment, align_const);<br />
        }<br />
        // 如果空间足够, 或者调用时不传入short_seg_end_p参数(传入nullptr), 则调用a_fit_segment_end_p函数<br />
        // If the caller doesn't care, we always try to fit at the end of seg;<br />
        // otherwise we would only try if we are actually not short at end of seg.<br />
        if (!short_seg_end_p || !(*short_seg_end_p))<br />
        {<br />
            can_allocate = a_fit_segment_end_p (gen_number, ephemeral_heap_segment, size,<br />
                                                acontext, align_const, commit_failed_p);<br />
        }<br />
    }

    return can_allocate;<br />
}<br />
</code></pre>
<p>a_fit_free_list_p函数的内容: <a href="https://raw.githubusercontent.com/dotnet/coreclr/release/1.1.0/src/gc/gc.cpp" rel="external nofollow noreferrer">https://raw.githubusercontent.com/dotnet/coreclr/release/1.1.0/src/gc/gc.cpp</a><br /><br />
这个函数会尝试从自由对象列表中找到足够大小的空间, 如果找到则把分配上下文指向这个空间</p>
<pre class="prettyprint linenums"><code>inline<br />
BOOL gc_heap::a_fit_free_list_p (int gen_number,<br />
                                 size_t size,<br />
                                 alloc_context* acontext,<br />
                                 int align_const)<br />
{<br />
    BOOL can_fit = FALSE;<br />
    // 获取指定的代中的自由对象列表<br />
    generation* gen = generation_of (gen_number);<br />
    allocator* gen_allocator = generation_allocator (gen);<br />
    // 列表会按大小分为多个bucket(用链表形式链接)<br />
    // 大小会*2递增, 例如first_bucket的大小是256那第二个bucket的大小则为512<br />
    size_t sz_list = gen_allocator-&gt;first_bucket_size();<br />
    for (unsigned int a_l_idx = 0; a_l_idx &lt; gen_allocator-&gt;number_of_buckets(); a_l_idx++)<br />
    {<br />
        if ((size &lt; sz_list) || (a_l_idx == (gen_allocator-&gt;number_of_buckets()-1)))<br />
        {<br />
            uint8_t* free_list = gen_allocator-&gt;alloc_list_head_of (a_l_idx);<br />
            uint8_t* prev_free_item = 0;

            while (free_list != 0)<br />
            {<br />
                dprintf (3, (&quot;considering free list %Ix&quot;, (size_t)free_list));<br />
                size_t free_list_size = unused_array_size (free_list);<br />
                if ((size + Align (min_obj_size, align_const)) &lt;= free_list_size)<br />
                {<br />
                    dprintf (3, (&quot;Found adequate unused area: [%Ix, size: %Id&quot;,<br />
                                 (size_t)free_list, free_list_size));

                    // 大小足够时从该bucket的链表中pop出来<br />
                    gen_allocator-&gt;unlink_item (a_l_idx, free_list, prev_free_item, FALSE);<br />
                    // We ask for more Align (min_obj_size)<br />
                    // to make sure that we can insert a free object<br />
                    // in adjust_limit will set the limit lower<br />
                    size_t limit = limit_from_size (size, free_list_size, gen_number, align_const);

                    uint8_t*  remain = (free_list + limit);<br />
                    size_t remain_size = (free_list_size - limit);<br />
                    // 如果分配完还有剩余空间, 在剩余空间生成一个自由对象并塞回自由对象列表<br />
                    if (remain_size &gt;= Align(min_free_list, align_const))<br />
                    {<br />
                        make_unused_array (remain, remain_size);<br />
                        gen_allocator-&gt;thread_item_front (remain, remain_size);<br />
                        assert (remain_size &gt;= Align (min_obj_size, align_const));<br />
                    }<br />
                    else<br />
                    {<br />
                        //absorb the entire free list<br />
                        limit += remain_size;<br />
                    }<br />
                    generation_free_list_space (gen) -= limit;

                    // 给分配上下文设置新的范围<br />
                    adjust_limit_clr (free_list, limit, acontext, 0, align_const, gen_number);

                    // 分配成功跳出循环<br />
                    can_fit = TRUE;<br />
                    goto end;<br />
                }<br />
                else if (gen_allocator-&gt;discard_if_no_fit_p())<br />
                {<br />
                    assert (prev_free_item == 0);<br />
                    dprintf (3, (&quot;couldn't use this free area, discarding&quot;));<br />
                    generation_free_obj_space (gen) += free_list_size;

                    gen_allocator-&gt;unlink_item (a_l_idx, free_list, prev_free_item, FALSE);<br />
                    generation_free_list_space (gen) -= free_list_size;<br />
                }<br />
                else<br />
                {<br />
                    prev_free_item = free_list;<br />
                }<br />
                // 同一bucket的下一个自由对象<br />
                free_list = free_list_slot (free_list);<br />
            }<br />
        }<br />
        // 当前bucket的大小不够, 下一个bucket的大小会是当前bucket的两倍<br />
        sz_list = sz_list * 2;<br />
    }<br />
end:<br />
    return can_fit;<br />
}<br />
</code></pre>
<p>a_fit_segment_end_p函数的内容: <a href="https://raw.githubusercontent.com/dotnet/coreclr/release/1.1.0/src/gc/gc.cpp" rel="external nofollow noreferrer">https://raw.githubusercontent.com/dotnet/coreclr/release/1.1.0/src/gc/gc.cpp</a><br /><br />
这个函数会尝试在堆段的结尾找到一块足够大小的空间, 如果找到则把分配上下文指向这个空间</p>
<pre class="prettyprint linenums"><code>BOOL gc_heap::a_fit_segment_end_p (int gen_number,<br />
                                   heap_segment* seg,<br />
                                   size_t size,<br />
                                   alloc_context* acontext,<br />
                                   int align_const,<br />
                                   BOOL* commit_failed_p)<br />
{<br />
    *commit_failed_p = FALSE;<br />
    size_t limit = 0;<br />
#ifdef BACKGROUND_GC<br />
    int cookie = -1;<br />
#endif //BACKGROUND_GC

    // 开始分配的地址<br />
    uint8_t*&amp; allocated = ((gen_number == 0) ?<br />
                        alloc_allocated :<br />
                        heap_segment_allocated(seg));

    size_t pad = Align (min_obj_size, align_const);

#ifdef FEATURE_LOH_COMPACTION<br />
    if (gen_number == (max_generation + 1))<br />
    {<br />
        pad += Align (loh_padding_obj_size, align_const);<br />
    }<br />
#endif //FEATURE_LOH_COMPACTION

    // 最多能分配到的地址 = 已提交到物理内存的地址 - 对齐大小<br />
    uint8_t* end = heap_segment_committed (seg) - pad;

    // 如果空间足够则跳到found_fit<br />
    if (a_size_fit_p (size, allocated, end, align_const))<br />
    {<br />
        limit = limit_from_size (size,<br />
                                 (end - allocated),<br />
                                 gen_number, align_const);<br />
        goto found_fit;<br />
    }

    // 已提交到物理内存的地址不够用, 需要提交新的地址<br />
    // 最多能分配到的地址 = 堆段预留的末尾地址 - 对齐大小<br />
    end = heap_segment_reserved (seg) - pad;

    // 如果空间足够则调用grow_heap_segment<br />
    // 调用grow_heap_segment成功则跳到found_fit, 否则设置commit_failed_p的值等于true<br />
    if (a_size_fit_p (size, allocated, end, align_const))<br />
    {<br />
        limit = limit_from_size (size,<br />
                                 (end - allocated),<br />
                                 gen_number, align_const);<br />
        if (grow_heap_segment (seg, allocated + limit))<br />
        {<br />
            goto found_fit;<br />
        }<br />
        else<br />
        {<br />
            dprintf (2, (&quot;can't grow segment, doing a full gc&quot;));<br />
            *commit_failed_p = TRUE;<br />
        }<br />
    }<br />
    goto found_no_fit;

found_fit:

    // 如果启用了后台GC, 并且正在分配大对象, 需要检测后台GC是否正在标记对象<br />
#ifdef BACKGROUND_GC<br />
    if (gen_number != 0)<br />
    {<br />
        cookie = bgc_alloc_lock-&gt;loh_alloc_set (allocated);<br />
    }<br />
#endif //BACKGROUND_GC

    uint8_t* old_alloc;<br />
    old_alloc = allocated;<br />
    // 如果是第3代(大对象)则往对齐的空间添加一个自由对象<br />
#ifdef FEATURE_LOH_COMPACTION<br />
    if (gen_number == (max_generation + 1))<br />
    {<br />
        size_t loh_pad = Align (loh_padding_obj_size, align_const);<br />
        make_unused_array (old_alloc, loh_pad);<br />
        old_alloc += loh_pad;<br />
        allocated += loh_pad;<br />
        limit -= loh_pad;<br />
    }<br />
#endif //FEATURE_LOH_COMPACTION

    // 清空SyncBlock<br />
    // 正常不需要, 因为前一个对象已经清零并预留好空间<br />
#if defined (VERIFY_HEAP) &amp;&amp; defined (_DEBUG)<br />
        ((void**) allocated)[-1] = 0;     //clear the sync block<br />
#endif //VERIFY_HEAP &amp;&amp; _DEBUG<br />
    // 增加开始分配的地址, 下一次将会从这里分配<br />
    // 注意这个不是本地变量而是引用<br />
    allocated += limit;

    dprintf (3, (&quot;found fit at end of seg: %Ix&quot;, old_alloc));

#ifdef BACKGROUND_GC<br />
    if (cookie != -1)<br />
    {<br />
        // 如果后台GC正在标记对象需要调用bgc_loh_alloc_clr给分配上下文设置新的范围<br />
        // 这个函数会在下一节(分配大对象内存的代码流程)解释<br />
        bgc_loh_alloc_clr (old_alloc, limit, acontext, align_const, cookie, TRUE, seg);<br />
    }<br />
    else<br />
#endif //BACKGROUND_GC<br />
    {<br />
        // 给分配上下文设置新的范围<br />
        adjust_limit_clr (old_alloc, limit, acontext, seg, align_const, gen_number);<br />
    }

    return TRUE;

found_no_fit:

    return FALSE;<br />
}<br />
</code></pre>
<p>adjust_limit_clr函数的内容: <a href="https://raw.githubusercontent.com/dotnet/coreclr/release/1.1.0/src/gc/gc.cpp" rel="external nofollow noreferrer">https://raw.githubusercontent.com/dotnet/coreclr/release/1.1.0/src/gc/gc.cpp</a><br /><br />
这个函数会给分配上下文设置新的范围<br /><br />
不管是从自由列表还是堆段的结尾分配都会调用这个函数, 从自由列表分配时seg参数会是nullptr<br /><br />
调用完这个函数以后分配上下文就有足够的空间了, 回到gc_heap::allocate的retry就可以成功的分配到对象的内存</p>
<pre class="prettyprint linenums"><code>void gc_heap::adjust_limit_clr (uint8_t* start, size_t limit_size,<br />
                                alloc_context* acontext, heap_segment* seg,<br />
                                int align_const, int gen_number)<br />
{<br />
    size_t aligned_min_obj_size = Align(min_obj_size, align_const);

    //probably should pass seg==0 for free lists.<br />
    if (seg)<br />
    {<br />
        assert (heap_segment_used (seg) &lt;= heap_segment_committed (seg));<br />
    }

    dprintf (3, (&quot;Expanding segment allocation [%Ix, %Ix[&quot;, (size_t)start,<br />
               (size_t)start + limit_size - aligned_min_obj_size));

    // 如果分配上下文的开始地址改变了, 并且原来的空间未用完(只是不够用), 应该在这个空间创建一个自由对象<br />
    // 这里就是BOTR中说的如果剩下30bytes但是要分配40bytes时会在原来的30bytes创建一个自由对象<br />
    // 但如果只是结束地址改变了, 开始地址未改变则不需要<br />
    if ((acontext-&gt;alloc_limit != start) &amp;&amp;<br />
        (acontext-&gt;alloc_limit + aligned_min_obj_size)!= start)<br />
    {<br />
        uint8_t*  hole = acontext-&gt;alloc_ptr;<br />
        if (hole != 0)<br />
        {<br />
            size_t  size = (acontext-&gt;alloc_limit - acontext-&gt;alloc_ptr);<br />
            dprintf (3, (&quot;filling up hole [%Ix, %Ix[&quot;, (size_t)hole, (size_t)hole + size + Align (min_obj_size, align_const)));<br />
            // when we are finishing an allocation from a free list<br />
            // we know that the free area was Align(min_obj_size) larger<br />
            acontext-&gt;alloc_bytes -= size;<br />
            size_t free_obj_size = size + aligned_min_obj_size;<br />
            make_unused_array (hole, free_obj_size);<br />
            generation_free_obj_space (generation_of (gen_number)) += free_obj_size;<br />
        }<br />
        // 设置新的开始地址<br />
        acontext-&gt;alloc_ptr = start;<br />
    }<br />
    // 设置新的结束地址<br />
    acontext-&gt;alloc_limit = (start + limit_size - aligned_min_obj_size);<br />
    // 添加已分配的字节数<br />
    acontext-&gt;alloc_bytes += limit_size - ((gen_number &lt; max_generation + 1) ? aligned_min_obj_size : 0);

#ifdef FEATURE_APPDOMAIN_RESOURCE_MONITORING<br />
    if (g_fEnableARM)<br />
    {<br />
        AppDomain* alloc_appdomain = GetAppDomain();<br />
        alloc_appdomain-&gt;RecordAllocBytes (limit_size, heap_number);<br />
    }<br />
#endif //FEATURE_APPDOMAIN_RESOURCE_MONITORING

    uint8_t* saved_used = 0;

    if (seg)<br />
    {<br />
        saved_used = heap_segment_used (seg);<br />
    }

    // 如果传入了seg参数, 调整heap_segment::used的位置<br />
    if (seg == ephemeral_heap_segment)<br />
    {<br />
        //Sometimes the allocated size is advanced without clearing the<br />
        //memory. Let's catch up here<br />
        if (heap_segment_used (seg) &lt; (alloc_allocated - plug_skew))<br />
        {<br />
#ifdef MARK_ARRAY<br />
#ifndef BACKGROUND_GC<br />
            clear_mark_array (heap_segment_used (seg) + plug_skew, alloc_allocated);<br />
#endif //BACKGROUND_GC<br />
#endif //MARK_ARRAY<br />
            heap_segment_used (seg) = alloc_allocated - plug_skew;<br />
        }<br />
    }<br />
#ifdef BACKGROUND_GC<br />
    else if (seg)<br />
    {<br />
        uint8_t* old_allocated = heap_segment_allocated (seg) - plug_skew - limit_size;<br />
#ifdef FEATURE_LOH_COMPACTION<br />
        old_allocated -= Align (loh_padding_obj_size, align_const);<br />
#endif //FEATURE_LOH_COMPACTION

        assert (heap_segment_used (seg) &gt;= old_allocated);<br />
    }<br />
#endif //BACKGROUND_GC

    // 对设置的空间进行清0<br />
    // plug_skew其实就是SyncBlock的大小, 这里会把start前面的一个SyncBlock也清0<br />
    // 对大块内存的清0会比较耗费时间, 清0之前会释放掉MSL锁<br />
    if ((seg == 0) ||<br />
        (start - plug_skew + limit_size) &lt;= heap_segment_used (seg))<br />
    {<br />
        dprintf (SPINLOCK_LOG, (&quot;[%d]Lmsl to clear memory(1)&quot;, heap_number));<br />
        add_saved_spinlock_info (me_release, mt_clr_mem);<br />
        leave_spin_lock (&amp;more_space_lock);<br />
        dprintf (3, (&quot;clearing memory at %Ix for %d bytes&quot;, (start - plug_skew), limit_size));<br />
        memclr (start - plug_skew, limit_size);<br />
    }<br />
    else<br />
    {<br />
        uint8_t* used = heap_segment_used (seg);<br />
        heap_segment_used (seg) = start + limit_size - plug_skew;

        dprintf (SPINLOCK_LOG, (&quot;[%d]Lmsl to clear memory&quot;, heap_number));<br />
        add_saved_spinlock_info (me_release, mt_clr_mem);<br />
        leave_spin_lock (&amp;more_space_lock);<br />
        if ((start - plug_skew) &lt; used)<br />
        {<br />
            if (used != saved_used)<br />
            {<br />
                FATAL_GC_ERROR ();<br />
            }

            dprintf (2, (&quot;clearing memory before used at %Ix for %Id bytes&quot;,<br />
                (start - plug_skew), (plug_skew + used - start)));<br />
            memclr (start - plug_skew, used - (start - plug_skew));<br />
        }<br />
    }

    // 设置BrickTable<br />
    // BrickTable中属于start的块会设置为alloc_ptr距离块开始地址的大小<br />
    // 之后一直到start + limit的块会设置为-1<br />
    //this portion can be done after we release the lock<br />
    if (seg == ephemeral_heap_segment)<br />
    {<br />
#ifdef FFIND_OBJECT<br />
        if (gen0_must_clear_bricks &gt; 0)<br />
        {<br />
            //set the brick table to speed up find_object<br />
            size_t b = brick_of (acontext-&gt;alloc_ptr);<br />
            set_brick (b, acontext-&gt;alloc_ptr - brick_address (b));<br />
            b++;<br />
            dprintf (3, (&quot;Allocation Clearing bricks [%Ix, %Ix[&quot;,<br />
                         b, brick_of (align_on_brick (start + limit_size))));<br />
            volatile short* x = &amp;brick_table [b];<br />
            short* end_x = &amp;brick_table [brick_of (align_on_brick (start + limit_size))];

            for (;x &lt; end_x;x++)<br />
                *x = -1;<br />
        }<br />
        else<br />
#endif //FFIND_OBJECT<br />
        {<br />
            gen0_bricks_cleared = FALSE;<br />
        }<br />
    }

    // verifying the memory is completely cleared.<br />
    //verify_mem_cleared (start - plug_skew, limit_size);<br />
}<br />
</code></pre>
<p>总结小对象内存的代码流程</p>
<ul><li>allocate: 尝试从分配上下文分配内存, 失败时调用allocate_more_space为分配上下文指定新的空间</p>
<ul><li>allocate_more_space: 调用try_allocate_more_space函数</p>
<ul><li>try_allocate_more_space: 检查是否有必要触发GC, 然后根据gen_number参数调用allocate_small或allocate_large函数</p>
<ul><li>allocate_small: 循环尝试进行各种回收内存的处理和调用soh_try_fit函数</p>
<ul><li>soh_try_fit: 先尝试调用a_fit_free_list_p从自由对象列表中分配, 然后尝试调用a_fit_segment_end_p从堆段结尾分配</p>
<ul><li>a_fit_free_list_p: 尝试从自由对象列表中找到足够大小的空间, 如果找到则把分配上下文指向这个空间</p>
<ul><li>adjust_limit_clr: 给分配上下文设置新的范围</li></ul></li>
<li>a_fit_segment_end_p: 尝试在堆段的结尾找到一块足够大小的空间, 如果找到则把分配上下文指向这个空间
<ul><li>adjust_limit_clr: 给分配上下文设置新的范围</li></ul></li></ul></li></ul></li></ul></li></ul></li></ul></li></ul>
<h3>分配大对象内存的代码流程</h3>
<p>让我们来看一下大对象的内存是如何分配的<br /><br />
分配小对象我们从gc_heap::allocate开始跟踪, 这里我们从gc_heap::allocate_large_object开始跟踪</p>
<p>allocate_large_object函数的内容: <a href="https://raw.githubusercontent.com/dotnet/coreclr/release/1.1.0/src/gc/gc.cpp" rel="external nofollow noreferrer">https://raw.githubusercontent.com/dotnet/coreclr/release/1.1.0/src/gc/gc.cpp</a><br /><br />
这个函数和allocate函数不同的是它不会尝试从分配上下文中分配, 而是直接从堆段中分配</p>
<pre class="prettyprint linenums"><code>CObjectHeader* gc_heap::allocate_large_object (size_t jsize, int64_t&amp; alloc_bytes)<br />
{<br />
    // 创建一个空的分配上下文<br />
    //create a new alloc context because gen3context is shared.<br />
    alloc_context acontext;<br />
    acontext.alloc_ptr = 0;<br />
    acontext.alloc_limit = 0;<br />
    acontext.alloc_bytes = 0;<br />
#ifdef MULTIPLE_HEAPS<br />
    acontext.alloc_heap = vm_heap;<br />
#endif //MULTIPLE_HEAPS

#ifdef MARK_ARRAY<br />
    uint8_t* current_lowest_address = lowest_address;<br />
    uint8_t* current_highest_address = highest_address;<br />
#ifdef BACKGROUND_GC<br />
    if (recursive_gc_sync::background_running_p())<br />
    {<br />
        current_lowest_address = background_saved_lowest_address;<br />
        current_highest_address = background_saved_highest_address;<br />
    }<br />
#endif //BACKGROUND_GC<br />
#endif // MARK_ARRAY

    // 检查对象大小是否超过了最大允许的对象大小<br />
    // 超过时分配失败<br />
    size_t maxObjectSize = (INT32_MAX - 7 - Align(min_obj_size));

#ifdef BIT64<br />
    if (g_pConfig-&gt;GetGCAllowVeryLargeObjects())<br />
    {<br />
        maxObjectSize = (INT64_MAX - 7 - Align(min_obj_size));<br />
    }<br />
#endif

    if (jsize &gt;= maxObjectSize)<br />
    {<br />
        if (g_pConfig-&gt;IsGCBreakOnOOMEnabled())<br />
        {<br />
            GCToOSInterface::DebugBreak();<br />
        }

#ifndef FEATURE_REDHAWK<br />
        ThrowOutOfMemoryDimensionsExceeded();<br />
#else<br />
        return 0;<br />
#endif<br />
    }

    // 计算对齐<br />
    size_t size = AlignQword (jsize);<br />
    int align_const = get_alignment_constant (FALSE);<br />
#ifdef FEATURE_LOH_COMPACTION<br />
    size_t pad = Align (loh_padding_obj_size, align_const);<br />
#else<br />
    size_t pad = 0;<br />
#endif //FEATURE_LOH_COMPACTION

    // 调用allocate_more_space函数<br />
    // 因为分配上下文是空的, 这里我们给分配上下文指定的空间就是这个大对象使用的空间<br />
    assert (size &gt;= Align (min_obj_size, align_const));<br />
#ifdef _MSC_VER<br />
#pragma inline_depth(0)<br />
#endif //_MSC_VER<br />
    if (! allocate_more_space (&amp;acontext, (size + pad), max_generation+1))<br />
    {<br />
        return 0;<br />
    }

#ifdef _MSC_VER<br />
#pragma inline_depth(20)<br />
#endif //_MSC_VER

#ifdef FEATURE_LOH_COMPACTION<br />
    // The GC allocator made a free object already in this alloc context and<br />
    // adjusted the alloc_ptr accordingly.<br />
#endif //FEATURE_LOH_COMPACTION

    // 对象分配到刚才获取到的空间的开始地址<br />
    uint8_t*  result = acontext.alloc_ptr;

    // 空间大小应该等于对象大小<br />
    assert ((size_t)(acontext.alloc_limit - acontext.alloc_ptr) == size);

    // 返回结果<br />
    CObjectHeader* obj = (CObjectHeader*)result;

#ifdef MARK_ARRAY<br />
    if (recursive_gc_sync::background_running_p())<br />
    {<br />
        // 如果对象不在扫描范围中清掉标记的bit<br />
        if ((result &lt; current_highest_address) &amp;&amp; (result &gt;= current_lowest_address))<br />
        {<br />
            dprintf (3, (&quot;Clearing mark bit at address %Ix&quot;,<br />
                     (size_t)(&amp;mark_array [mark_word_of (result)])));

            mark_array_clear_marked (result);<br />
        }<br />
#ifdef BACKGROUND_GC<br />
        //the object has to cover one full mark uint32_t<br />
        assert (size &gt; mark_word_size);<br />
        if (current_c_gc_state == c_gc_state_marking)<br />
        {<br />
            dprintf (3, (&quot;Concurrent allocation of a large object %Ix&quot;,<br />
                        (size_t)obj));<br />
            // 如果对象在扫描范围中则设置标记bit防止它被回收<br />
            //mark the new block specially so we know it is a new object<br />
            if ((result &lt; current_highest_address) &amp;&amp; (result &gt;= current_lowest_address))<br />
            {<br />
                dprintf (3, (&quot;Setting mark bit at address %Ix&quot;,<br />
                            (size_t)(&amp;mark_array [mark_word_of (result)])));

                mark_array_set_marked (result);<br />
            }<br />
        }<br />
#endif //BACKGROUND_GC<br />
    }<br />
#endif //MARK_ARRAY

    assert (obj != 0);<br />
    assert ((size_t)obj == Align ((size_t)obj, align_const));

    alloc_bytes += acontext.alloc_bytes;<br />
    return obj;<br />
}<br />
</code></pre>
<p>allocate_more_space这个函数我们在之前已经看过了, 忘掉的可以向前翻<br /><br />
这个函数会调用try_allocate_more_space函数<br /><br />
try_allocate_more_space函数在分配大对象时会调用allocate_large函数</p>
<p>allocate_large函数的内容: <a href="https://raw.githubusercontent.com/dotnet/coreclr/release/1.1.0/src/gc/gc.cpp" rel="external nofollow noreferrer">https://raw.githubusercontent.com/dotnet/coreclr/release/1.1.0/src/gc/gc.cpp</a><br /><br />
这个函数的结构和alloc_small相似但是内部处理的细节不一样</p>
<pre class="prettyprint linenums"><code>BOOL gc_heap::allocate_large (int gen_number,<br />
                              size_t size,<br />
                              alloc_context* acontext,<br />
                              int align_const)<br />
{<br />
    // 后台GC运行时且不在计划阶段<br />
    // 原来是16次处理1次但是现在if被注释了<br />
#ifdef BACKGROUND_GC<br />
    if (recursive_gc_sync::background_running_p() &amp;&amp; (current_c_gc_state != c_gc_state_planning))<br />
    {<br />
        background_loh_alloc_count++;<br />
        //if ((background_loh_alloc_count % bgc_alloc_spin_count_loh) == 0)<br />
        {<br />
            // 如果合适在后台GC完成前分配对象<br />
            if (bgc_loh_should_allocate())<br />
            {<br />
                // 如果记录的LOH(Large Object Heap)增长比较大则这个线程需要暂停一下, 先安排其他线程工作<br />
                // 释放MSL锁并调用YieldThread, 如果switchCount参数(bgc_alloc_spin_loh)较大还有可能休眠1ms<br />
                if (!bgc_alloc_spin_loh)<br />
                {<br />
                    Thread* current_thread = GetThread();<br />
                    add_saved_spinlock_info (me_release, mt_alloc_large);<br />
                    dprintf (SPINLOCK_LOG, (&quot;[%d]spin Lmsl loh&quot;, heap_number));<br />
                    leave_spin_lock (&amp;more_space_lock);<br />
                    BOOL cooperative_mode = enable_preemptive (current_thread);<br />
                    GCToOSInterface::YieldThread (bgc_alloc_spin_loh);<br />
                    disable_preemptive (current_thread, cooperative_mode);<br />
                    enter_spin_lock (&amp;more_space_lock);<br />
                    add_saved_spinlock_info (me_acquire, mt_alloc_large);<br />
                    dprintf (SPINLOCK_LOG, (&quot;[%d]spin Emsl loh&quot;, heap_number));<br />
                }<br />
            }<br />
            // 不合适时等待后台GC完成<br />
            else<br />
            {<br />
                wait_for_background (awr_loh_alloc_during_bgc);<br />
            }<br />
        }<br />
    }<br />
#endif //BACKGROUND_GC

    gc_reason gr = reason_oos_loh;<br />
    generation* gen = generation_of (gen_number);<br />
    oom_reason oom_r = oom_no_failure;<br />
    size_t current_full_compact_gc_count = 0;

    // No variable values should be &quot;carried over&quot; from one state to the other.<br />
    // That's why there are local variable for each state<br />
    allocation_state loh_alloc_state = a_state_start;<br />
#ifdef RECORD_LOH_STATE<br />
    EEThreadId current_thread_id;<br />
    current_thread_id.SetToCurrentThread();<br />
#endif //RECORD_LOH_STATE

    // 开始循环切换状态, 请关注loh_alloc_state<br />
    // If we can get a new seg it means allocation will succeed.<br />
    while (1)<br />
    {<br />
        dprintf (3, (&quot;[h%d]loh state is %s&quot;, heap_number, allocation_state_str[loh_alloc_state]));

#ifdef RECORD_LOH_STATE<br />
        add_saved_loh_state (loh_alloc_state, current_thread_id);<br />
#endif //RECORD_LOH_STATE<br />
        switch (loh_alloc_state)<br />
        {<br />
            // 成功或失败时跳出循环<br />
            case a_state_can_allocate:<br />
            case a_state_cant_allocate:<br />
            {<br />
                goto exit;<br />
            }<br />
            // 开始时切换状态到a_state_try_fit<br />
            case a_state_start:<br />
            {<br />
                loh_alloc_state = a_state_try_fit;<br />
                break;<br />
            }<br />
            // 调用loh_try_fit函数<br />
            // 成功时切换状态到a_state_can_allocate<br />
            // 失败时切换状态到a_state_trigger_full_compact_gc或a_state_acquire_seg<br />
            case a_state_try_fit:<br />
            {<br />
                BOOL commit_failed_p = FALSE;<br />
                BOOL can_use_existing_p = FALSE;

                can_use_existing_p = loh_try_fit (gen_number, size, acontext,<br />
                                                  align_const, &amp;commit_failed_p, &amp;oom_r);<br />
                loh_alloc_state = (can_use_existing_p ?<br />
                                        a_state_can_allocate :<br />
                                        (commit_failed_p ?<br />
                                            a_state_trigger_full_compact_gc :<br />
                                            a_state_acquire_seg));<br />
                assert ((loh_alloc_state == a_state_can_allocate) == (acontext-&gt;alloc_ptr != 0));<br />
                break;<br />
            }<br />
            // 在创建了一个新的堆段以后调用loh_try_fit函数<br />
            // 成功时切换状态到a_state_can_allocate<br />
            // 失败时切换状态到a_state_try_fit<br />
            case a_state_try_fit_new_seg:<br />
            {<br />
                BOOL commit_failed_p = FALSE;<br />
                BOOL can_use_existing_p = FALSE;

                can_use_existing_p = loh_try_fit (gen_number, size, acontext,<br />
                                                  align_const, &amp;commit_failed_p, &amp;oom_r);<br />
                // 即使我们创建了一个新的堆段也不代表分配一定会成功，例如被其他线程抢走了，如果这样我们需要重试<br />
                // Even after we got a new seg it doesn't necessarily mean we can allocate,<br />
                // another LOH allocating thread could have beat us to acquire the msl so<br />
                // we need to try again.<br />
                loh_alloc_state = (can_use_existing_p ? a_state_can_allocate : a_state_try_fit);<br />
                assert ((loh_alloc_state == a_state_can_allocate) == (acontext-&gt;alloc_ptr != 0));<br />
                break;<br />
            }<br />
            // 在压缩GC后创建一个新的堆段成功, 调用loh_try_fit函数在这个堆段上分配<br />
            // 成功时切换状态到a_state_can_allocate<br />
            // 失败时如果提交到物理内存失败(物理内存不足)则切换状态到a_state_cant_allocate<br />
            // 否则再尝试一次创建一个新的堆段<br />
            case a_state_try_fit_new_seg_after_cg:<br />
            {<br />
                BOOL commit_failed_p = FALSE;<br />
                BOOL can_use_existing_p = FALSE;

                can_use_existing_p = loh_try_fit (gen_number, size, acontext,<br />
                                                  align_const, &amp;commit_failed_p, &amp;oom_r);<br />
                // Even after we got a new seg it doesn't necessarily mean we can allocate,<br />
                // another LOH allocating thread could have beat us to acquire the msl so<br />
                // we need to try again. However, if we failed to commit, which means we<br />
                // did have space on the seg, we bail right away 'cause we already did a<br />
                // full compacting GC.<br />
                loh_alloc_state = (can_use_existing_p ?<br />
                                        a_state_can_allocate :<br />
                                        (commit_failed_p ?<br />
                                            a_state_cant_allocate :<br />
                                            a_state_acquire_seg_after_cg));<br />
                assert ((loh_alloc_state == a_state_can_allocate) == (acontext-&gt;alloc_ptr != 0));<br />
                break;<br />
            }<br />
            // 这个状态目前不会被其他状态切换到<br />
            // 简单的调用loh_try_fit函数成功则切换到a_state_can_allocate失败则切换到a_state_cant_allocate<br />
            case a_state_try_fit_no_seg:<br />
            {<br />
                BOOL commit_failed_p = FALSE;<br />
                BOOL can_use_existing_p = FALSE;

                can_use_existing_p = loh_try_fit (gen_number, size, acontext,<br />
                                                  align_const, &amp;commit_failed_p, &amp;oom_r);<br />
                loh_alloc_state = (can_use_existing_p ? a_state_can_allocate : a_state_cant_allocate);<br />
                assert ((loh_alloc_state == a_state_can_allocate) == (acontext-&gt;alloc_ptr != 0));<br />
                assert ((loh_alloc_state != a_state_cant_allocate) || (oom_r != oom_no_failure));<br />
                break;<br />
            }<br />
            // 压缩GC完成后调用loh_try_fit函数<br />
            // 成功时切换状态到a_state_can_allocate<br />
            // 如果压缩后仍分配失败, 并且提交内存到物理内存失败(物理内存不足)则切换状态到a_state_cant_allocate<br />
            // 如果压缩后仍分配失败, 但是提交内存到物理内存并无失败则尝试再次创建一个新的堆段<br />
            case a_state_try_fit_after_cg:<br />
            {<br />
                BOOL commit_failed_p = FALSE;<br />
                BOOL can_use_existing_p = FALSE;

                can_use_existing_p = loh_try_fit (gen_number, size, acontext,<br />
                                                  align_const, &amp;commit_failed_p, &amp;oom_r);<br />
                loh_alloc_state = (can_use_existing_p ?<br />
                                        a_state_can_allocate :<br />
                                        (commit_failed_p ?<br />
                                            a_state_cant_allocate :<br />
                                            a_state_acquire_seg_after_cg));<br />
                assert ((loh_alloc_state == a_state_can_allocate) == (acontext-&gt;alloc_ptr != 0));<br />
                break;<br />
            }<br />
            // 在后台GC完成后调用loh_try_fit函数<br />
            // 成功时切换状态到a_state_can_allocate<br />
            // 如果提交内存到物理内存失败(物理内存不足)则切换状态到a_state_trigger_full_compact_gc<br />
            // 如果提交内存到物理内存并无失败则尝试创建一个新的堆段<br />
            case a_state_try_fit_after_bgc:<br />
            {<br />
                BOOL commit_failed_p = FALSE;<br />
                BOOL can_use_existing_p = FALSE;

                can_use_existing_p = loh_try_fit (gen_number, size, acontext,<br />
                                                  align_const, &amp;commit_failed_p, &amp;oom_r);<br />
                loh_alloc_state = (can_use_existing_p ?<br />
                                        a_state_can_allocate :<br />
                                        (commit_failed_p ?<br />
                                            a_state_trigger_full_compact_gc :<br />
                                            a_state_acquire_seg_after_bgc));<br />
                assert ((loh_alloc_state == a_state_can_allocate) == (acontext-&gt;alloc_ptr != 0));<br />
                break;<br />
            }<br />
            // 尝试创建一个新的堆段<br />
            // 成功时切换状态到a_state_try_fit_new_seg<br />
            // 失败时如果已执行了压缩则切换状态到a_state_check_retry_seg, 否则切换状态到a_state_check_and_wait_for_bgc<br />
            case a_state_acquire_seg:<br />
            {<br />
                BOOL can_get_new_seg_p = FALSE;<br />
                BOOL did_full_compacting_gc = FALSE;

                current_full_compact_gc_count = get_full_compact_gc_count();

                can_get_new_seg_p = loh_get_new_seg (gen, size, align_const, &amp;did_full_compacting_gc, &amp;oom_r);<br />
                loh_alloc_state = (can_get_new_seg_p ?<br />
                                        a_state_try_fit_new_seg :<br />
                                        (did_full_compacting_gc ?<br />
                                            a_state_check_retry_seg :<br />
                                            a_state_check_and_wait_for_bgc));<br />
                break;<br />
            }<br />
            // 尝试在压缩GC后创建一个新的堆段<br />
            // 成功时切换状态到a_state_try_fit_new_seg_after_cg<br />
            // 失败时切换状态到a_state_check_retry_seg<br />
            case a_state_acquire_seg_after_cg:<br />
            {<br />
                BOOL can_get_new_seg_p = FALSE;<br />
                BOOL did_full_compacting_gc = FALSE;

                current_full_compact_gc_count = get_full_compact_gc_count();

                can_get_new_seg_p = loh_get_new_seg (gen, size, align_const, &amp;did_full_compacting_gc, &amp;oom_r);<br />
                // Since we release the msl before we try to allocate a seg, other<br />
                // threads could have allocated a bunch of segments before us so<br />
                // we might need to retry.<br />
                loh_alloc_state = (can_get_new_seg_p ?<br />
                                        a_state_try_fit_new_seg_after_cg :<br />
                                        a_state_check_retry_seg);<br />
                break;<br />
            }<br />
            // 后台GC完成后尝试创建一个新的堆段<br />
            // 成功时切换状态到a_state_try_fit_new_seg<br />
            // 失败时如果已执行了压缩则切换状态到a_state_check_retry_seg, 否则切换状态到a_state_trigger_full_compact_gc<br />
            case a_state_acquire_seg_after_bgc:<br />
            {<br />
                BOOL can_get_new_seg_p = FALSE;<br />
                BOOL did_full_compacting_gc = FALSE;

                current_full_compact_gc_count = get_full_compact_gc_count();

                can_get_new_seg_p = loh_get_new_seg (gen, size, align_const, &amp;did_full_compacting_gc, &amp;oom_r);<br />
                loh_alloc_state = (can_get_new_seg_p ?<br />
                                        a_state_try_fit_new_seg :<br />
                                        (did_full_compacting_gc ?<br />
                                            a_state_check_retry_seg :<br />
                                            a_state_trigger_full_compact_gc));<br />
                assert ((loh_alloc_state != a_state_cant_allocate) || (oom_r != oom_no_failure));<br />
                break;<br />
            }<br />
            // 等待后台GC完成<br />
            // 如果后台GC不在运行状态中则切换状态到a_state_trigger_full_compact_gc<br />
            // 如果执行了压缩则切换状态到a_state_try_fit_after_cg, 否则切换状态到a_state_try_fit_after_bgc<br />
            case a_state_check_and_wait_for_bgc:<br />
            {<br />
                BOOL bgc_in_progress_p = FALSE;<br />
                BOOL did_full_compacting_gc = FALSE;

                if (fgn_maxgen_percent)<br />
                {<br />
                    dprintf (2, (&quot;FGN: failed to acquire seg, may need to do a full blocking GC&quot;));<br />
                    send_full_gc_notification (max_generation, FALSE);<br />
                }

                bgc_in_progress_p = check_and_wait_for_bgc (awr_loh_oos_bgc, &amp;did_full_compacting_gc);<br />
                loh_alloc_state = (!bgc_in_progress_p ?<br />
                                        a_state_trigger_full_compact_gc :<br />
                                        (did_full_compacting_gc ?<br />
                                            a_state_try_fit_after_cg :<br />
                                            a_state_try_fit_after_bgc));<br />
                break;<br />
            }<br />
            // 触发第0和1和2代的压缩GC<br />
            // 成功时切换状态到a_state_try_fit_after_cg, 失败时切换状态到a_state_cant_allocate<br />
            case a_state_trigger_full_compact_gc:<br />
            {<br />
                BOOL got_full_compacting_gc = FALSE;

                got_full_compacting_gc = trigger_full_compact_gc (gr, &amp;oom_r);<br />
                loh_alloc_state = (got_full_compacting_gc ? a_state_try_fit_after_cg : a_state_cant_allocate);<br />
                assert ((loh_alloc_state != a_state_cant_allocate) || (oom_r != oom_no_failure));<br />
                break;<br />
            }<br />
            // 检查是否应该重试GC或申请新的堆段<br />
            // 应该重试GC时切换状态到a_state_trigger_full_compact_gc<br />
            // 应该重试申请新的堆段时切换状态到a_state_acquire_seg_after_cg<br />
            // 否则切换状态到a_state_cant_allocate<br />
            // 如果不能获取一个新的堆段, 但是对原来的堆段执行了压缩GC那就应该重试<br />
            case a_state_check_retry_seg:<br />
            {<br />
                BOOL should_retry_gc = retry_full_compact_gc (size);<br />
                BOOL should_retry_get_seg = FALSE;<br />
                if (!should_retry_gc)<br />
                {<br />
                    size_t last_full_compact_gc_count = current_full_compact_gc_count;<br />
                    current_full_compact_gc_count = get_full_compact_gc_count();

                    if (current_full_compact_gc_count &gt; (last_full_compact_gc_count + 1))<br />
                    {<br />
                        should_retry_get_seg = TRUE;<br />
                    }<br />
                }

                loh_alloc_state = (should_retry_gc ?<br />
                                        a_state_trigger_full_compact_gc :<br />
                                        (should_retry_get_seg ?<br />
                                            a_state_acquire_seg_after_cg :<br />
                                            a_state_cant_allocate));<br />
                assert ((loh_alloc_state != a_state_cant_allocate) || (oom_r != oom_no_failure));<br />
                break;<br />
            }<br />
            default:<br />
            {<br />
                assert (!&quot;Invalid state!&quot;);<br />
                break;<br />
            }<br />
        }<br />
    }

exit:<br />
    // 分配失败时处理OOM(Out Of Memory)<br />
    if (loh_alloc_state == a_state_cant_allocate)<br />
    {<br />
        assert (oom_r != oom_no_failure);<br />
        handle_oom (heap_number,<br />
                    oom_r,<br />
                    size,<br />
                    0,<br />
                    0);

        add_saved_spinlock_info (me_release, mt_alloc_large_cant);<br />
        dprintf (SPINLOCK_LOG, (&quot;[%d]Lmsl for loh oom&quot;, heap_number));<br />
        leave_spin_lock (&amp;more_space_lock);<br />
    }

    return (loh_alloc_state == a_state_can_allocate);<br />
}<br />
</code></pre>
<p>loh_try_fit函数的内容: <a href="https://raw.githubusercontent.com/dotnet/coreclr/release/1.1.0/src/gc/gc.cpp" rel="external nofollow noreferrer">https://raw.githubusercontent.com/dotnet/coreclr/release/1.1.0/src/gc/gc.cpp</a><br /><br />
处理和soh_try_fit差不多, 先尝试调用a_fit_free_list_large_p从自由对象列表中分配, 然后尝试调用loh_a_fit_segment_end_p从堆段结尾分配</p>
<pre class="prettyprint linenums"><code>BOOL gc_heap::loh_try_fit (int gen_number,<br />
                           size_t size,<br />
                           alloc_context* acontext,<br />
                           int align_const,<br />
                           BOOL* commit_failed_p,<br />
                           oom_reason* oom_r)<br />
{<br />
    BOOL can_allocate = TRUE;

    // 尝试从自由对象列表分配<br />
    if (!a_fit_free_list_large_p (size, acontext, align_const))<br />
    {<br />
        // 尝试从堆段结尾分配<br />
        can_allocate = loh_a_fit_segment_end_p (gen_number, size,<br />
                                                acontext, align_const,<br />
                                                commit_failed_p, oom_r);

        // 后台GC运行时, 统计在堆段结尾分配的大小<br />
#ifdef BACKGROUND_GC<br />
        if (can_allocate &amp;&amp; recursive_gc_sync::background_running_p())<br />
        {<br />
            bgc_loh_size_increased += size;<br />
        }<br />
#endif //BACKGROUND_GC<br />
    }<br />
#ifdef BACKGROUND_GC<br />
    else<br />
    {<br />
        // 后台GC运行时, 统计在自由对象列表分配的大小<br />
        if (recursive_gc_sync::background_running_p())<br />
        {<br />
            bgc_loh_allocated_in_free += size;<br />
        }<br />
    }<br />
#endif //BACKGROUND_GC

    return can_allocate;<br />
}<br />
</code></pre>
<p>a_fit_free_list_large_p函数的内容: <a href="https://raw.githubusercontent.com/dotnet/coreclr/release/1.1.0/src/gc/gc.cpp" rel="external nofollow noreferrer">https://raw.githubusercontent.com/dotnet/coreclr/release/1.1.0/src/gc/gc.cpp</a><br /><br />
和a_fit_free_list_p的处理基本相同, 但是在支持LOH压缩时会生成填充对象, 并且有可能会调用bgc_loh_alloc_clr函数</p>
<pre class="prettyprint linenums"><code>BOOL gc_heap::a_fit_free_list_large_p (size_t size,<br />
                                       alloc_context* acontext,<br />
                                       int align_const)<br />
{<br />
    // 如果后台GC在计划阶段, 等待计划完成<br />
#ifdef BACKGROUND_GC<br />
    wait_for_background_planning (awr_loh_alloc_during_plan);<br />
#endif //BACKGROUND_GC

    // 获取第3代的自由对象列表<br />
    BOOL can_fit = FALSE;<br />
    int gen_number = max_generation + 1;<br />
    generation* gen = generation_of (gen_number);<br />
    allocator* loh_allocator = generation_allocator (gen); 

    // 支持LOH压缩时需要在大对象前塞一个填充对象<br />
#ifdef FEATURE_LOH_COMPACTION<br />
    size_t loh_pad = Align (loh_padding_obj_size, align_const);<br />
#endif //FEATURE_LOH_COMPACTION

#ifdef BACKGROUND_GC<br />
    int cookie = -1;<br />
#endif //BACKGROUND_GC<br />
    // 列表会按大小分为多个bucket(用链表形式链接)<br />
    // 大小会*2递增, 例如first_bucket的大小是256那第二个bucket的大小则为512<br />
    size_t sz_list = loh_allocator-&gt;first_bucket_size();<br />
    for (unsigned int a_l_idx = 0; a_l_idx &lt; loh_allocator-&gt;number_of_buckets(); a_l_idx++)<br />
    {<br />
        if ((size &lt; sz_list) || (a_l_idx == (loh_allocator-&gt;number_of_buckets()-1)))<br />
        {<br />
            uint8_t* free_list = loh_allocator-&gt;alloc_list_head_of (a_l_idx);<br />
            uint8_t* prev_free_item = 0;<br />
            while (free_list != 0)<br />
            {<br />
                dprintf (3, (&quot;considering free list %Ix&quot;, (size_t)free_list));

                size_t free_list_size = unused_array_size(free_list);

#ifdef FEATURE_LOH_COMPACTION<br />
                if ((size + loh_pad) &lt;= free_list_size)<br />
#else<br />
                if (((size + Align (min_obj_size, align_const)) &lt;= free_list_size)||<br />
                    (size == free_list_size))<br />
#endif //FEATURE_LOH_COMPACTION<br />
                {<br />
                    // 如果启用了后台GC, 并且正在分配大对象, 需要检测后台GC是否正在标记对象<br />
#ifdef BACKGROUND_GC<br />
                    cookie = bgc_alloc_lock-&gt;loh_alloc_set (free_list);<br />
#endif //BACKGROUND_GC

                    // 大小足够时从该bucket的链表中pop出来<br />
                    //unlink the free_item<br />
                    loh_allocator-&gt;unlink_item (a_l_idx, free_list, prev_free_item, FALSE);

                    // Substract min obj size because limit_from_size adds it. Not needed for LOH<br />
                    size_t limit = limit_from_size (size - Align(min_obj_size, align_const), free_list_size,<br />
                                                    gen_number, align_const);

                    // 支持LOH压缩时需要在大对象前塞一个填充对象<br />
#ifdef FEATURE_LOH_COMPACTION<br />
                    make_unused_array (free_list, loh_pad);<br />
                    limit -= loh_pad;<br />
                    free_list += loh_pad;<br />
                    free_list_size -= loh_pad;<br />
#endif //FEATURE_LOH_COMPACTION

                    // 如果分配完还有剩余空间, 在剩余空间生成一个自由对象并塞回自由对象列表<br />
                    uint8_t*  remain = (free_list + limit);<br />
                    size_t remain_size = (free_list_size - limit);<br />
                    if (remain_size != 0)<br />
                    {<br />
                        assert (remain_size &gt;= Align (min_obj_size, align_const));<br />
                        make_unused_array (remain, remain_size);<br />
                    }<br />
                    if (remain_size &gt;= Align(min_free_list, align_const))<br />
                    {<br />
                        loh_thread_gap_front (remain, remain_size, gen);<br />
                        assert (remain_size &gt;= Align (min_obj_size, align_const));<br />
                    }<br />
                    else<br />
                    {<br />
                        generation_free_obj_space (gen) += remain_size;<br />
                    }<br />
                    generation_free_list_space (gen) -= free_list_size;<br />
                    dprintf (3, (&quot;found fit on loh at %Ix&quot;, free_list));<br />
#ifdef BACKGROUND_GC<br />
                    if (cookie != -1)<br />
                    {<br />
                        // 如果后台GC正在标记对象需要调用bgc_loh_alloc_clr给分配上下文设置新的范围<br />
                        bgc_loh_alloc_clr (free_list, limit, acontext, align_const, cookie, FALSE, 0);<br />
                    }<br />
                    else<br />
#endif //BACKGROUND_GC<br />
                    {<br />
                        // 给分配上下文设置新的范围<br />
                        adjust_limit_clr (free_list, limit, acontext, 0, align_const, gen_number);<br />
                    }

                    //fix the limit to compensate for adjust_limit_clr making it too short<br />
                    acontext-&gt;alloc_limit += Align (min_obj_size, align_const);<br />
                    can_fit = TRUE;<br />
                    goto exit;<br />
                }<br />
                // 同一bucket的下一个自由对象<br />
                prev_free_item = free_list;<br />
                free_list = free_list_slot (free_list);<br />
            }<br />
        }<br />
        // 当前bucket的大小不够, 下一个bucket的大小会是当前bucket的两倍<br />
        sz_list = sz_list * 2;<br />
    }<br />
exit:<br />
    return can_fit;<br />
}<br />
</code></pre>
<p>adjust_limit_clr这个函数我们在看小对象的代码流程时已经看过<br /><br />
这里看bgc_loh_alloc_clr函数的内容: <a href="https://raw.githubusercontent.com/dotnet/coreclr/release/1.1.0/src/gc/gc.cpp" rel="external nofollow noreferrer">https://raw.githubusercontent.com/dotnet/coreclr/release/1.1.0/src/gc/gc.cpp</a><br /><br />
这个函数是在后台GC运行时分配大对象使用的, 需要照顾到运行中的后台GC</p>
<pre class="prettyprint linenums"><code>#ifdef BACKGROUND_GC<br />
void gc_heap::bgc_loh_alloc_clr (uint8_t* alloc_start,<br />
                                 size_t size,<br />
                                 alloc_context* acontext,<br />
                                 int align_const,<br />
                                 int lock_index,<br />
                                 BOOL check_used_p,<br />
                                 heap_segment* seg)<br />
{<br />
    // 一开始就在这片空间创建一个自由对象<br />
    // 因为等会要释放在bgc_alloc_lock中的锁再清0内存所以要先创建一个自由对象防止GC使用这块空间<br />
    // 这个自由对象在最后重新上锁后会被重置回空白的空间<br />
    make_unused_array (alloc_start, size);

#ifdef FEATURE_APPDOMAIN_RESOURCE_MONITORING<br />
    if (g_fEnableARM)<br />
    {<br />
        AppDomain* alloc_appdomain = GetAppDomain();<br />
        alloc_appdomain-&gt;RecordAllocBytes (size, heap_number);<br />
    }<br />
#endif //FEATURE_APPDOMAIN_RESOURCE_MONITORING

    size_t size_of_array_base = sizeof(ArrayBase);

    // 释放cookie对应的锁 (设置数组中lock_index位置的值为0)<br />
    bgc_alloc_lock-&gt;loh_alloc_done_with_index (lock_index);

    // 开始对内存进行清0<br />
    // 计算清0的的范围<br />
    // clear memory while not holding the lock.<br />
    size_t size_to_skip = size_of_array_base;<br />
    size_t size_to_clear = size - size_to_skip - plug_skew;<br />
    size_t saved_size_to_clear = size_to_clear;<br />
    if (check_used_p)<br />
    {<br />
        uint8_t* end = alloc_start + size - plug_skew;<br />
        uint8_t* used = heap_segment_used (seg);<br />
        if (used &lt; end)<br />
        {<br />
            if ((alloc_start + size_to_skip) &lt; used)<br />
            {<br />
                size_to_clear = used - (alloc_start + size_to_skip);<br />
            }<br />
            else<br />
            {<br />
                size_to_clear = 0;<br />
            }<br />
            // 调整heap_segment::used的位置<br />
            dprintf (2, (&quot;bgc loh: setting used to %Ix&quot;, end));<br />
            heap_segment_used (seg) = end;<br />
        }

        dprintf (2, (&quot;bgc loh: used: %Ix, alloc: %Ix, end of alloc: %Ix, clear %Id bytes&quot;,<br />
                     used, alloc_start, end, size_to_clear));<br />
    }<br />
    else<br />
    {<br />
        dprintf (2, (&quot;bgc loh: [%Ix-[%Ix(%Id)&quot;, alloc_start, alloc_start+size, size));<br />
    }

#ifdef VERIFY_HEAP<br />
    // since we filled in 0xcc for free object when we verify heap,<br />
    // we need to make sure we clear those bytes.<br />
    if (g_pConfig-&gt;GetHeapVerifyLevel() &amp; EEConfig::HEAPVERIFY_GC)<br />
    {<br />
        if (size_to_clear &lt; saved_size_to_clear)<br />
        {<br />
            size_to_clear = saved_size_to_clear;<br />
        }<br />
    }<br />
#endif //VERIFY_HEAP

    // 释放MSL锁并清0内存<br />
    dprintf (SPINLOCK_LOG, (&quot;[%d]Lmsl to clear large obj&quot;, heap_number));<br />
    add_saved_spinlock_info (me_release, mt_clr_large_mem);<br />
    leave_spin_lock (&amp;more_space_lock);<br />
    memclr (alloc_start + size_to_skip, size_to_clear);

    // 重新找一个锁锁上<br />
    // 这里的锁会在PublishObject时释放<br />
    bgc_alloc_lock-&gt;loh_alloc_set (alloc_start);

    // 设置分配上下文指向的范围<br />
    acontext-&gt;alloc_ptr = alloc_start;<br />
    acontext-&gt;alloc_limit = (alloc_start + size - Align (min_obj_size, align_const));

    // 把自由对象重新变回一块空白的空间<br />
    // need to clear the rest of the object before we hand it out.<br />
    clear_unused_array(alloc_start, size);<br />
}<br />
#endif //BACKGROUND_GC<br />
</code></pre>
<p>loh_a_fit_segment_end_p函数的内容: <a href="https://raw.githubusercontent.com/dotnet/coreclr/release/1.1.0/src/gc/gc.cpp" rel="external nofollow noreferrer">https://raw.githubusercontent.com/dotnet/coreclr/release/1.1.0/src/gc/gc.cpp</a><br /><br />
这个函数会遍历第3代的堆段链表逐个调用a_fit_segment_end_p函数尝试分配</p>
<pre class="prettyprint linenums"><code>BOOL gc_heap::loh_a_fit_segment_end_p (int gen_number,<br />
                                       size_t size,<br />
                                       alloc_context* acontext,<br />
                                       int align_const,<br />
                                       BOOL* commit_failed_p,<br />
                                       oom_reason* oom_r)<br />
{<br />
    *commit_failed_p = FALSE;<br />
    // 获取代中第一个堆段节点用于接下来的分配<br />
    heap_segment* seg = generation_allocation_segment (generation_of (gen_number));<br />
    BOOL can_allocate_p = FALSE;

    while (seg)<br />
    {<br />
        // 调用a_fit_segment_end_p尝试在这个堆段的结尾分配<br />
        if (a_fit_segment_end_p (gen_number, seg, (size - Align (min_obj_size, align_const)),<br />
                                 acontext, align_const, commit_failed_p))<br />
        {<br />
            acontext-&gt;alloc_limit += Align (min_obj_size, align_const);<br />
            can_allocate_p = TRUE;<br />
            break;<br />
        }<br />
        else<br />
        {<br />
            if (*commit_failed_p)<br />
            {<br />
                // 如果堆段还有剩余空间但不能提交到物理内存, 则返回内存不足错误<br />
                *oom_r = oom_cant_commit;<br />
                break;<br />
            }<br />
            else<br />
            {<br />
                // 如果堆段已无剩余空间, 看链表中的下一个堆段<br />
                seg = heap_segment_next_rw (seg);<br />
            }<br />
        }<br />
    }

    return can_allocate_p;<br />
}<br />
</code></pre>
<p>总结大对象内存的代码流程</p>
<ul><li>allocate_large_object: 调用allocate_more_space为一个空的分配上下文指定新的空间, 空间大小会等于对象的大小</p>
<ul><li>allocate_more_space: 调用try_allocate_more_space函数</p>
<ul><li>try_allocate_more_space: 检查是否有必要触发GC, 然后根据gen_number参数调用allocate_small或allocate_large函数</p>
<ul><li>allocate_large: 循环尝试进行各种回收内存的处理和调用soh_try_fit函数</p>
<ul><li>loh_try_fit: 先尝试调用a_fit_free_list_large_p从自由对象列表中分配, 然后尝试调用loh_a_fit_segment_end_p从堆段结尾分配</p>
<ul><li>a_fit_free_list_large_p: 尝试从自由对象列表中找到足够大小的空间, 如果找到则把分配上下文指向这个空间</p>
<ul><li>bgc_loh_alloc_clr: 给分配上下文设置新的范围, 照顾到后台GC</li>
<li>adjust_limit_clr: 给分配上下文设置新的范围</li></ul></li>
<li>loh_a_fit_segment_end_p: 遍历第3代的堆段链表逐个调用a_fit_segment_end_p函数尝试分配
<ul><li>a_fit_segment_end_p: 尝试在堆段的结尾找到一块足够大小的空间, 如果找到则把分配上下文指向这个空间</p>
<ul><li>bgc_loh_alloc_clr: 给分配上下文设置新的范围, 照顾到后台GC</li>
<li>adjust_limit_clr: 给分配上下文设置新的范围</li></ul></li></ul></li></ul></li></ul></li></ul></li></ul></li></ul></li></ul>
<h3>CoreCLR如何管理系统内存 (windows, linux)</h3>
<p>看到这里我们应该知道分配上下文, 小对象, 大对象的内存都是来源于堆段, 那堆段的内存来源于哪里呢?<br /><br />
GC在程序启动时会创建默认的堆段, 调用流程是init_gc_heap =&gt; get_initial_segment =&gt; make_heap_segment<br /><br />
如果默认的堆段不够用会创建新的堆段<br /><br />
小对象的堆段会通过<code>gc1 =&gt; plan_phase =&gt; soh_get_segment_to_expand =&gt; get_segment =&gt; make_heap_segment</code>创建<br /><br />
大对象的堆段会通过<code>allocate_large =&gt; loh_get_new_seg =&gt; get_large_segment =&gt; get_segment_for_loh =&gt; get_segment =&gt; make_heap_segment</code>创建</p>
<p>默认的堆段会通过next_initial_memory分配内存, 这一块内存在程序启动时从reserve_initial_memory函数申请<br /><br />
reserve_initial_memory函数和make_heap_segment函数都会调用virtual_alloc函数</p>
<p>因为调用流程很长我这里就不一个个函数贴代码了, 有兴趣的可以自己去跟踪<br /><br />
virtual_alloc函数的调用流程是</p>
<pre class="prettyprint linenums"><code>virtual_alloc =&gt; GCToOSInterface::VirtualReserve =&gt; ClrVirtualAllocAligned =&gt; ClrVirtualAlloc =&gt;<br />
CExecutionEngine::ClrVirtualAlloc =&gt; EEVirtualAlloc =&gt; VirtualAlloc<br />
</code></pre>
<p>如果是windows, VirtualAlloc就是同名的windows api<br /><br />
如果是linux或者macosx, 调用流程是VirtualAlloc =&gt; VIRTUALReserveMemory =&gt; ReserveVirtualMemory<br /><br />
ReserveVirtualMemory函数会调用mmap函数</p>
<p>ReserveVirtualMemory函数的内容: <a href="https://github.com/dotnet/coreclr/blob/release/1.1.0/src/pal/src/map/virtual.cpp#L894" rel="external nofollow noreferrer">https://github.com/dotnet/coreclr/blob/release/1.1.0/src/pal/src/map/virtual.cpp#L894</a></p>
<pre class="prettyprint linenums"><code>static LPVOID ReserveVirtualMemory(<br />
                IN CPalThread *pthrCurrent, /* Currently executing thread */<br />
                IN LPVOID lpAddress,        /* Region to reserve or commit */<br />
                IN SIZE_T dwSize)           /* Size of Region */<br />
{<br />
    UINT_PTR StartBoundary = (UINT_PTR)lpAddress;<br />
    SIZE_T MemSize = dwSize;

    TRACE( &quot;Reserving the memory now.\n&quot;);

    // Most platforms will only commit memory if it is dirtied,<br />
    // so this should not consume too much swap space.<br />
    int mmapFlags = 0;

#if HAVE_VM_ALLOCATE<br />
    // Allocate with vm_allocate first, then map at the fixed address.<br />
    int result = vm_allocate(mach_task_self(),<br />
                             &amp;StartBoundary,<br />
                             MemSize,<br />
                             ((LPVOID) StartBoundary != nullptr) ? FALSE : TRUE);

    if (result != KERN_SUCCESS)<br />
    {<br />
        ERROR(&quot;vm_allocate failed to allocated the requested region!\n&quot;);<br />
        pthrCurrent-&gt;SetLastError(ERROR_INVALID_ADDRESS);<br />
        return nullptr;<br />
    }

    mmapFlags |= MAP_FIXED;<br />
#endif // HAVE_VM_ALLOCATE

    mmapFlags |= MAP_ANON | MAP_PRIVATE;

    LPVOID pRetVal = mmap((LPVOID) StartBoundary,<br />
                          MemSize,<br />
                          PROT_NONE,<br />
                          mmapFlags,<br />
                          -1 /* fd */,<br />
                          0  /* offset */);

    if (pRetVal == MAP_FAILED)<br />
    {<br />
        ERROR( &quot;Failed due to insufficient memory.\n&quot; );

#if HAVE_VM_ALLOCATE<br />
        vm_deallocate(mach_task_self(), StartBoundary, MemSize);<br />
#endif // HAVE_VM_ALLOCATE

        pthrCurrent-&gt;SetLastError(ERROR_NOT_ENOUGH_MEMORY);<br />
        return nullptr;<br />
    }

    /* Check to see if the region is what we asked for. */<br />
    if (lpAddress != nullptr &amp;&amp; StartBoundary != (UINT_PTR)pRetVal)<br />
    {<br />
        ERROR(&quot;We did not get the region we asked for from mmap!\n&quot;);<br />
        pthrCurrent-&gt;SetLastError(ERROR_INVALID_ADDRESS);<br />
        munmap(pRetVal, MemSize);<br />
        return nullptr;<br />
    }

#if MMAP_ANON_IGNORES_PROTECTION<br />
    if (mprotect(pRetVal, MemSize, PROT_NONE) != 0)<br />
    {<br />
        ERROR(&quot;mprotect failed to protect the region!\n&quot;);<br />
        pthrCurrent-&gt;SetLastError(ERROR_INVALID_ADDRESS);<br />
        munmap(pRetVal, MemSize);<br />
        return nullptr;<br />
    }<br />
#endif  // MMAP_ANON_IGNORES_PROTECTION

    return pRetVal;<br />
}<br />
</code></pre>
<p>CoreCLR在从系统申请内存时会使用VirtualAlloc或mmap模拟的VirtualAlloc<br /><br />
申请后会得到一块尚未完全提交到物理内存的虚拟内存(注意保护模式是PROT_NONE, 表示该块内存不能读写执行, 内核无需设置它的PageTable)<br /><br />
如果你有兴趣可以看一下CoreCLR的虚拟内存占用, 工作站GC启动时就占了1G多, 服务器GC启动时就占用了20G</p>
<p>之后CoreCLR会根据使用慢慢的把使用的部分提交到物理内存, 流程是</p>
<pre class="prettyprint linenums"><code>GCToOSInterface::VirtualCommit =&gt; ClrVirtualAlloc =&gt; CExecutionEngine::ClrVirtualAlloc =&gt;<br />
EEVirtualAlloc =&gt; VirtualAlloc<br />
</code></pre>
<p>如果是windows, VirtualAlloc是同名的windowsapi, 地址会被显式指定且页保护模式为可读写(PAGE_READWRITE)<br /><br />
如果是linux或者macosx, VirtualAlloc会调用VIRTUALCommitMemory, 且内部会调用mprotect来设置该页为可读写(PROT_READ|PROT_WRITE)</p>
<p>当GC回收了垃圾对象, 不再需要部分内存时会把内存还给系统, 例如回收小对象后的流程是</p>
<pre class="prettyprint linenums"><code>gc1 =&gt; decommit_ephemeral_segment_pages =&gt; decommit_heap_segment_pages =&gt; GCToOSInterface::VirtualDecommit<br />
</code></pre>
<p>GCToOSInterface::VirtualDecommit的调用流程是</p>
<pre class="prettyprint linenums"><code>GCToOSInterface::VirtualDecommit =&gt; ClrVirtualFree =&gt; CExecutionEngine::ClrVirtualFree =&gt;<br />
EEVirtualFree =&gt; VirtualFree<br />
</code></pre>
<p>如果是windows, VirtualFree是同名的windowsapi, 表示该部分虚拟内存已经不再使用内核可以重置它们的PageTable<br /><br />
如果是linux或者macosx, VirtualFree通过mprotect模拟, 设置该页的保护模式为PROT_NONE</p>
<p>VirtualFree函数的内容: <a href="https://github.com/dotnet/coreclr/blob/release/1.1.0/src/pal/src/map/virtual.cpp#L1291" rel="external nofollow noreferrer">https://github.com/dotnet/coreclr/blob/release/1.1.0/src/pal/src/map/virtual.cpp#L1291</a></p>
<pre class="prettyprint linenums"><code>BOOL<br />
PALAPI<br />
VirtualFree(<br />
        IN LPVOID lpAddress,    /* Address of region. */<br />
        IN SIZE_T dwSize,       /* Size of region. */<br />
        IN DWORD dwFreeType )   /* Operation type. */<br />
{<br />
    BOOL bRetVal = TRUE;<br />
    CPalThread *pthrCurrent;

    PERF_ENTRY(VirtualFree);<br />
    ENTRY(&quot;VirtualFree(lpAddress=%p, dwSize=%u, dwFreeType=%#x)\n&quot;,<br />
          lpAddress, dwSize, dwFreeType);

    pthrCurrent = InternalGetCurrentThread();<br />
    InternalEnterCriticalSection(pthrCurrent, &amp;virtual_critsec);

    /* Sanity Checks. */<br />
    if ( !lpAddress )<br />
    {<br />
        ERROR( &quot;lpAddress cannot be NULL. You must specify the base address of\<br />
               regions to be de-committed. \n&quot; );<br />
        pthrCurrent-&gt;SetLastError( ERROR_INVALID_ADDRESS );<br />
        bRetVal = FALSE;<br />
        goto VirtualFreeExit;<br />
    }

    if ( !( dwFreeType &amp; MEM_RELEASE ) &amp;&amp; !(dwFreeType &amp; MEM_DECOMMIT ) )<br />
    {<br />
        ERROR( &quot;dwFreeType must contain one of the following: \<br />
               MEM_RELEASE or MEM_DECOMMIT\n&quot; );<br />
        pthrCurrent-&gt;SetLastError( ERROR_INVALID_PARAMETER );<br />
        bRetVal = FALSE;<br />
        goto VirtualFreeExit;<br />
    }<br />
    /* You cannot release and decommit in one call.*/<br />
    if ( dwFreeType &amp; MEM_RELEASE &amp;&amp; dwFreeType &amp; MEM_DECOMMIT )<br />
    {<br />
        ERROR( &quot;MEM_RELEASE cannot be combined with MEM_DECOMMIT.\n&quot; );<br />
        bRetVal = FALSE;<br />
        goto VirtualFreeExit;<br />
    }

    if ( dwFreeType &amp; MEM_DECOMMIT )<br />
    {<br />
        UINT_PTR StartBoundary  = 0;<br />
        SIZE_T MemSize        = 0;

        if ( dwSize == 0 )<br />
        {<br />
            ERROR( &quot;dwSize cannot be 0. \n&quot; );<br />
            pthrCurrent-&gt;SetLastError( ERROR_INVALID_PARAMETER );<br />
            bRetVal = FALSE;<br />
            goto VirtualFreeExit;<br />
        }<br />
        /*<br />
         * A two byte range straddling 2 pages caues both pages to be either<br />
         * released or decommitted. So round the dwSize up to the next page<br />
         * boundary and round the lpAddress down to the next page boundary.<br />
         */<br />
        MemSize = (((UINT_PTR)(dwSize) + ((UINT_PTR)(lpAddress) &amp; VIRTUAL_PAGE_MASK)<br />
                    + VIRTUAL_PAGE_MASK) &amp; ~VIRTUAL_PAGE_MASK);

        StartBoundary = (UINT_PTR)lpAddress &amp; ~VIRTUAL_PAGE_MASK;

        PCMI pUnCommittedMem;<br />
        pUnCommittedMem = VIRTUALFindRegionInformation( StartBoundary );<br />
        if (!pUnCommittedMem)<br />
        {<br />
            ASSERT( &quot;Unable to locate the region information.\n&quot; );<br />
            pthrCurrent-&gt;SetLastError( ERROR_INTERNAL_ERROR );<br />
            bRetVal = FALSE;<br />
            goto VirtualFreeExit;<br />
        }

        TRACE( &quot;Un-committing the following page(s) %d to %d.\n&quot;,<br />
               StartBoundary, MemSize );

        // Explicitly calling mmap instead of mprotect here makes it<br />
        // that much more clear to the operating system that we no<br />
        // longer need these pages.<br />
        if ( mmap( (LPVOID)StartBoundary, MemSize, PROT_NONE,<br />
                   MAP_FIXED | MAP_ANON | MAP_PRIVATE, -1, 0 ) != MAP_FAILED )<br />
        {<br />
#if (MMAP_ANON_IGNORES_PROTECTION)<br />
            if (mprotect((LPVOID) StartBoundary, MemSize, PROT_NONE) != 0)<br />
            {<br />
                ASSERT(&quot;mprotect failed to protect the region!\n&quot;);<br />
                pthrCurrent-&gt;SetLastError(ERROR_INTERNAL_ERROR);<br />
                munmap((LPVOID) StartBoundary, MemSize);<br />
                bRetVal = FALSE;<br />
                goto VirtualFreeExit;<br />
            }<br />
#endif  // MMAP_ANON_IGNORES_PROTECTION

            SIZE_T index = 0;<br />
            SIZE_T nNumOfPagesToChange = 0;

            /* We can now commit this memory by calling VirtualAlloc().*/<br />
            index = (StartBoundary - pUnCommittedMem-&gt;startBoundary) / VIRTUAL_PAGE_SIZE;

            nNumOfPagesToChange = MemSize / VIRTUAL_PAGE_SIZE;<br />
            VIRTUALSetAllocState( MEM_RESERVE, index,<br />
                                  nNumOfPagesToChange, pUnCommittedMem );

            goto VirtualFreeExit;<br />
        }<br />
        else<br />
        {<br />
            ASSERT( &quot;mmap() returned an abnormal value.\n&quot; );<br />
            bRetVal = FALSE;<br />
            pthrCurrent-&gt;SetLastError( ERROR_INTERNAL_ERROR );<br />
            goto VirtualFreeExit;<br />
        }<br />
    }

    if ( dwFreeType &amp; MEM_RELEASE )<br />
    {<br />
        PCMI pMemoryToBeReleased =<br />
            VIRTUALFindRegionInformation( (UINT_PTR)lpAddress );

        if ( !pMemoryToBeReleased )<br />
        {<br />
            ERROR( &quot;lpAddress must be the base address returned by VirtualAlloc.\n&quot; );<br />
            pthrCurrent-&gt;SetLastError( ERROR_INVALID_ADDRESS );<br />
            bRetVal = FALSE;<br />
            goto VirtualFreeExit;<br />
        }<br />
        if ( dwSize != 0 )<br />
        {<br />
            ERROR( &quot;dwSize must be 0 if you are releasing the memory.\n&quot; );<br />
            pthrCurrent-&gt;SetLastError( ERROR_INVALID_PARAMETER );<br />
            bRetVal = FALSE;<br />
            goto VirtualFreeExit;<br />
        }

        TRACE( &quot;Releasing the following memory %d to %d.\n&quot;,<br />
               pMemoryToBeReleased-&gt;startBoundary, pMemoryToBeReleased-&gt;memSize );

        if ( munmap( (LPVOID)pMemoryToBeReleased-&gt;startBoundary,<br />
                     pMemoryToBeReleased-&gt;memSize ) == 0 )<br />
        {<br />
            if ( VIRTUALReleaseMemory( pMemoryToBeReleased ) == FALSE )<br />
            {<br />
                ASSERT( &quot;Unable to remove the PCMI entry from the list.\n&quot; );<br />
                pthrCurrent-&gt;SetLastError( ERROR_INTERNAL_ERROR );<br />
                bRetVal = FALSE;<br />
                goto VirtualFreeExit;<br />
            }<br />
            pMemoryToBeReleased = NULL;<br />
        }<br />
        else<br />
        {<br />
            ASSERT( &quot;Unable to unmap the memory, munmap() returned an abnormal value.\n&quot; );<br />
            pthrCurrent-&gt;SetLastError( ERROR_INTERNAL_ERROR );<br />
            bRetVal = FALSE;<br />
            goto VirtualFreeExit;<br />
        }<br />
    }

VirtualFreeExit:

    LogVaOperation(<br />
        (dwFreeType &amp; MEM_DECOMMIT) ? VirtualMemoryLogging::VirtualOperation::Decommit<br />
                                    : VirtualMemoryLogging::VirtualOperation::Release,<br />
        lpAddress,<br />
        dwSize,<br />
        dwFreeType,<br />
        0,<br />
        NULL,<br />
        bRetVal);

    InternalLeaveCriticalSection(pthrCurrent, &amp;virtual_critsec);<br />
    LOGEXIT( &quot;VirtualFree returning %s.\n&quot;, bRetVal == TRUE ? &quot;TRUE&quot; : &quot;FALSE&quot; );<br />
    PERF_EXIT(VirtualFree);<br />
    return bRetVal;<br />
}<br />
</code></pre>
<p>我们可以看出, CoreCLR管理系统内存的方式比较底层<br /><br />
在windows上使用了VirtualAlloc和VirtualFree<br /><br />
在linux上使用了mmap和mprotect<br /><br />
而不是使用传统的malloc和new<br /><br />
这样会带来更好的性能但同时增加了移植到其他平台的成本</p>
<h3>动态调试GC分配对象内存的过程</h3>
<p>要深入学习CoreCLR光看代码是很难做到的, 比如这次大部分来源的gc.cpp有接近37000行的代码,<br /><br />
为了很好的了解CoreCLR的工作原理这次我自己编译了CoreCLR并在本地用lldb进行了调试, 这里我分享一下编译和调试的过程<br /><br />
这里我使用了ubuntu 16.04 LTS, 因为linux上部署编译环境比windows要简单很多</p>
<p>下载CORECLR:</p>
<pre class="prettyprint linenums"><code>git clone https://github.com/dotnet/coreclr.git<br />
</code></pre>
<p>切换到你正在使用的版本, 请务必切换不要直接去编译master分支</p>
<pre class="prettyprint linenums"><code>git checkout v1.1.0<br />
</code></pre>
<p>参考微软的帮助安装好需要的包</p>
<pre class="prettyprint linenums"><code># https://github.com/dotnet/coreclr/blob/master/Documentation/building/linux-instructions.md<br />
echo &quot;deb http://llvm.org/apt/trusty/ llvm-toolchain-trusty-3.6 main&quot; | sudo tee /etc/apt/sources.list.d/llvm.list<br />
wget -O - http://llvm.org/apt/llvm-snapshot.gpg.key | sudo apt-key add -<br />
sudo apt-get update<br />
sudo apt-get install cmake llvm-3.5 clang-3.5 lldb-3.6 lldb-3.6-dev libunwind8 libunwind8-dev gettext libicu-dev liblttng-ust-dev libcurl4-openssl-dev libssl-dev uuid-dev<br />
cd coreclr<br />
./build.sh<br />
</code></pre>
<p>执行build.sh会从微软的网站下载一些东西, 如果很长时间都下载不成功你应该考虑挂点什么东西<br /><br />
编译过程需要几十分钟, 完成以后可以在<code>coreclr/bin/Product/Linux.x64.Debug</code>下看到编译结果</p>
<p>完成以后用dotnet创建一个新的可执行项目, 在project.json中添加runtimes节</p>
<pre class="prettyprint linenums"><code>{<br />
	&quot;runtimes&quot;: {<br />
		&quot;ubuntu.16.04-x64&quot;: {}<br />
	}<br />
}<br />
</code></pre>
<p>Program.cs的代码可以随意写, 想测哪部分就写哪部分的代码，我这里写的是多线程分配内存然后释放的代码</p>
<pre class="prettyprint linenums"><code>using System;<br />
using System.Threading;<br />
using System.Collections.Generic;

namespace ConsoleApplication<br />
{<br />
    public class A<br />
    {<br />
        public int a;<br />
        public byte[] padding;<br />
    }

    public class Program<br />
    {<br />
        public static void ThreadBody()<br />
        {<br />
            Thread.Sleep(1000);<br />
            var list = new List&lt;A&gt;();<br />
            for (long x = 0; x &lt; 1000000; ++x) {<br />
                list.Add(new A());<br />
            }<br />
        }

        public static void Main(string[] args)<br />
        {<br />
            var threads = new List&lt;Thread&gt;();<br />
            for (var x = 0; x &lt; 100; ++x)<br />
            {<br />
                var thread = new Thread(ThreadBody);<br />
                threads.Add(thread);<br />
                thread.Start();<br />
            }<br />
            foreach (var thread in threads)<br />
            {<br />
                thread.Join();<br />
            }<br />
            GC.Collect();<br />
            Console.WriteLine(&quot;memory released&quot;);<br />
            Console.ReadLine();<br />
        }<br />
    }<br />
}<br />
</code></pre>
<p>写完以后编译并发布</p>
<pre class="prettyprint linenums"><code>dotnet restore<br />
dotnet publish<br />
</code></pre>
<p>发布后<code>bin/Debug/netcoreapp1.1/ubuntu16.04-x64/publish</code>会多出最终发布的文件<br /><br />
把刚才CoreCLR编译出来的<code>coreclr/bin/Product/Linux.x64.Debug</code>下的所有文件复制到<code>publish</code>目录下, 并覆盖原有文件<br /><br />
微软官方的调试文档可见 <a href="https://github.com/dotnet/coreclr/blob/release/1.1.0/Documentation/building/debugging-instructions.md" rel="external nofollow noreferrer">https://github.com/dotnet/coreclr/blob/release/1.1.0/Documentation/building/debugging-instructions.md</a></p>
<p>使用lldb启动进程, 这里我项目名称是coreapp所以publish下的可执行文件名称也是coreapp</p>
<pre class="prettyprint linenums"><code>lldb-3.6 ./coreapp<br />
</code></pre>
<p>启动进程后可以打命令来调试, 需要中断(暂停)程序运行可以按下ctrl+c<br /><br />
<img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/881857/201702/881857-20170208171101651-1908730423.jpg"><br /><br />
这张图中的命令</p>
<pre class="prettyprint linenums"><code>b allocate_small<br />
给函数下断点, 这里的allocate_small虽然全名是SVR::gc_heap::allocate_small或WKS::gc_heap::allocate_small<br />
但是lldb允许用短名称下断点, 碰到多个符合的函数会一并截取

r<br />
运行程序, 之前在pending中的断点如果在程序运行后可以确定内存位置则实际的添加断点

bt<br />
查看当前的堆栈调用树, 可以看当前被调用的函数的来源是哪些函数<br />
</code></pre>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/881857/201702/881857-20170208171112510-757061854.jpg"><br /><br />
这张图中的命令</p>
<pre class="prettyprint linenums"><code>n<br />
步过, 遇到函数不会进去, 如果需要步进可以用s<br />
另外步过汇编和步进汇编是ni和si

fr v<br />
查看当前堆栈帧中的变量<br />
也就是传入的参数和本地变量

p acontext-&gt;alloc_ptr<br />
p *acontext<br />
打印全局或本地变量的值, 这个命令是调试中必用的命令, 不仅支持查看变量还支持计算表达式<br />
</code></pre>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/881857/201702/881857-20170208171120463-1219248840.jpg"><br /><br />
这张图中的命令</p>
<pre class="prettyprint linenums"><code>c<br />
继续中断进程直到退出或下一个断点

br del<br />
删除之前设置的所有断点<br />
</code></pre>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/881857/201702/881857-20170208171131916-486336280.jpg"><br /><br />
这张图显示的是线程列表中的第一个线程的分配上下文内容, 0x168可以通过<code>p &amp;((Thread*)nullptr)-&gt;m_Link</code>计算得出(就是offsetof)<br /><br />
这张图中的命令</p>
<pre class="prettyprint linenums"><code>me re -s4 -fx -c12 0x00007fff5c006f00<br />
读取0x00007fff5c006f00开始的内存, 单位是4byte, 表现形式是hex, 显示12个单位<br />
</code></pre>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/881857/201702/881857-20170208171142619-717717486.jpg"><br /><br />
lldb不仅能调试CoreCLR自身的代码<br /><br />
还能用来调试用户写的程序代码, 需要微软的SOS插件支持<br /><br />
详细可以看微软的官方文档 <a href="https://github.com/dotnet/coreclr/blob/release/1.1.0/Documentation/building/debugging-instructions.md" rel="external nofollow noreferrer">https://github.com/dotnet/coreclr/blob/release/1.1.0/Documentation/building/debugging-instructions.md</a></p>
<p>最后附上在这次分析中我常用的lldb命令<br /><br />
学习lldb可以查看官方的<a href="http://lldb.llvm.org/tutorial.html" rel="external nofollow noreferrer">Tutorial</a>和<a href="http://lldb.llvm.org/lldb-gdb.html" rel="external nofollow noreferrer">GDB and LLDB command examples</a></p>
<pre class="prettyprint linenums"><code>plugin load libsosplugin.so<br />
process launch -s<br />
process handle -s false SIGUSR1 SIGUSR2<br />
breakpoint set -n LoadLibraryExW<br />
c<br />
sos DumpHeap

bpmd coreapp.dll ConsoleApplication.Program.Main

p g_pGCHeap<br />
p n_heaps<br />
p g_heaps[0]<br />
p *WKS::gc_heap::ephemeral_heap_segment<br />
p g_heaps[0]-&gt;ephemeral_heap_segment

p s_pThreadStore-&gt;m_ThreadList<br />
p &amp;((Thread*)nullptr)-&gt;m_Link<br />
p ((Thread*)((char*)s_pThreadStore-&gt;m_ThreadList.m_link.m_pNext-0x168))-&gt;m_alloc_context<br />
p ((Thread*)((char*)s_pThreadStore-&gt;m_ThreadList.m_link.m_pNext-&gt;m_pNext-0x168))-&gt;m_alloc_context

me re -s4 -fx -c100 0x00007fff5c027fe0

p generation_table<br />
p generation_table[0]<br />
p generation_table[2].free_list_allocator<br />
p generation_table[2].free_list_allocator.first_bucket.head<br />
p (generation_table[2].free_list_allocator.buckets)-&gt;head<br />
p (generation_table[2].free_list_allocator.buckets+1)-&gt;head<br />
p *generation_table[2].free_list_allocator.buckets

wa s v generation_table[2].free_list_allocator.first_bucket.head<br />
me re -s8 -fx -c3 0x00007fff5bfff018<br />
</code></pre>
<h3>参考链接</h3>
<p><a href="https://github.com/dotnet/coreclr/blob/master/Documentation/botr/garbage-collection.md" rel="external nofollow noreferrer">https://github.com/dotnet/coreclr/blob/master/Documentation/botr/garbage-collection.md</a><br /><br />
<a href="https://github.com/dotnet/coreclr/blob/release/1.1.0/src/gc/gcsvr.cpp" rel="external nofollow noreferrer">https://github.com/dotnet/coreclr/blob/release/1.1.0/src/gc/gcsvr.cpp</a><br /><br />
<a href="https://github.com/dotnet/coreclr/blob/release/1.1.0/src/gc/gcwks.cpp" rel="external nofollow noreferrer">https://github.com/dotnet/coreclr/blob/release/1.1.0/src/gc/gcwks.cpp</a><br /><br />
<a href="https://github.com/dotnet/coreclr/blob/release/1.1.0/src/gc/gcimpl.h" rel="external nofollow noreferrer">https://github.com/dotnet/coreclr/blob/release/1.1.0/src/gc/gcimpl.h</a><br /><br />
<a href="https://github.com/dotnet/coreclr/blob/release/1.1.0/src/gc/gcpriv.h" rel="external nofollow noreferrer">https://github.com/dotnet/coreclr/blob/release/1.1.0/src/gc/gcpriv.h</a><br /><br />
<a href="https://github.com/dotnet/coreclr/blob/release/1.1.0/src/gc/gc.h#L162" rel="external nofollow noreferrer">https://github.com/dotnet/coreclr/blob/release/1.1.0/src/gc/gc.h#L162</a><br /><br />
<a href="https://github.com/dotnet/coreclr/blob/release/1.1.0/src/vm/gchelpers.cpp#L931" rel="external nofollow noreferrer">https://github.com/dotnet/coreclr/blob/release/1.1.0/src/vm/gchelpers.cpp#L931</a><br /><br />
<a href="https://raw.githubusercontent.com/dotnet/coreclr/release/1.1.0/src/gc/gc.cpp" rel="external nofollow noreferrer">https://raw.githubusercontent.com/dotnet/coreclr/release/1.1.0/src/gc/gc.cpp</a><br /><br />
<a href="https://github.com/dotnet/coreclr/blob/release/1.1.0/src/pal/src/map/virtual.cpp#L894" rel="external nofollow noreferrer">https://github.com/dotnet/coreclr/blob/release/1.1.0/src/pal/src/map/virtual.cpp#L894</a><br /><br />
<a href="https://github.com/dotnet/coreclr/blob/master/Documentation/building/linux-instructions.md" rel="external nofollow noreferrer">https://github.com/dotnet/coreclr/blob/master/Documentation/building/linux-instructions.md</a><br /><br />
<a href="https://github.com/dotnet/coreclr/blob/release/1.1.0/Documentation/building/debugging-instructions.md" rel="external nofollow noreferrer">https://github.com/dotnet/coreclr/blob/release/1.1.0/Documentation/building/debugging-instructions.md</a><br /><br />
<a href="https://docs.microsoft.com/en-us/dotnet/articles/core/tools/project-json" rel="external nofollow noreferrer">https://docs.microsoft.com/en-us/dotnet/articles/core/tools/project-json</a><br /><br />
<a href="https://github.com/dotnet/coreclr/issues/8959" rel="external nofollow noreferrer">https://github.com/dotnet/coreclr/issues/8959</a><br /><br />
<a href="https://github.com/dotnet/coreclr/issues/8995" rel="external nofollow noreferrer">https://github.com/dotnet/coreclr/issues/8995</a><br /><br />
<a href="https://github.com/dotnet/coreclr/issues/9053" rel="external nofollow noreferrer">https://github.com/dotnet/coreclr/issues/9053</a></p>
<p>因为gc的代码实在庞大并且注释少, 这次的分析我不仅在官方的github上提问了还动用到lldb才能做到初步的理解<br /><br />
下一篇我将讲解GC内存回收器的内部实现, 可能需要的时间更长, 请耐心等待吧</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/xq4pyv5q.html">《C&num;微信开发系列（2）-自定义菜单管理》</a>
		</li>
						<li><a href="https://www.batexi.com/a/495lepv8.html">apr 内存管理</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qxgo6e9.html">I&sol;O存取方式的形象比喻</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kydjr9.html">公司ERP系统重构那些事</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qnr6wk9.html">使用jQuery基本过滤选择器</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdej57x9.html">hdu 2255 奔小康赚大钱 KM算法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdn3o38.html">MVC5&plus;EF6&plus;BootStrap3&period;3&period;5  博客系统之EF（一）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdyn438.html">struts2学习笔记（2）---Action中訪问ServletAPI获取Map类型的Servlet元素</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1o3538.html">sql management studio 附加mdf文件出错的解决办法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8menww6q.html">一个解析RTSP 的URL函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kppjlr9.html">基于j2ee的程序代写MVC架构</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlj16m19.html">win10应用UserControl</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zo4rxdq.html">【Objective-C 基础】4&period;分类和协议</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2mr1oq.html">ArcGIS中KML转为shp文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/9605y2j9.html">Confluence 6 用户宏示例 - Color and Size</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ppj6gk9.html">sonar Lint ----code bad smell</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnnvzgkq.html">django-TDD</a>
		</li>
						<li><a href="https://www.batexi.com/a/902n56oq.html">Java和C&plus;&plus;通过Socket通信中文乱码的解决</a>
		</li>
						<li><a href="https://www.batexi.com/a/953kr268.html">Python PIL &colon; IOError&colon; decoder jpeg not available</a>
		</li>
						<li><a href="https://www.batexi.com/a/953klxz8.html">《集体智慧编程》第7章代码 Python3执行出错</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qnj2nxk8.html">Cantor表  1083</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4zmpo59.html">数据降维技术（2）&mdash;奇异值分解（SVD）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwj5oor8.html">nginx keepalived 主从切换</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jznnxe8.html">ZOJ 3927 Programming Ability Test</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pdkk5k9.html">Java 的Object类</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwj50jk8.html">rapidjson 使用教程</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy14r22q.html">jQuery 页面加载事件</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kpn5rr9.html">基于MDK编程STM32程序无法使用，硬件仿真在汇编窗口看到停留在&OpenCurlyDoubleQuote;0x0800XXXX BEAB BKPT 0xAB &sol;&sol;进入调试模式&rdquo;</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1kpl569.html">iOS开发&mdash;&mdash;工厂模式</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pdk33z9.html">&period;NET反射</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
